<?php
/**
 * Projekt: WS-Defender
 *          IP-Adressen nach Requests für ungültige Seiten blockieren
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.10.2021
 *
 * Fehler-Seite bei ungültigen Aufrufen.
 * in .htaddess steht:
 * ErrorDocument 403 /WS-Reporter/block.php
 * ErrorDocument 404 /WS-Reporter/block.php
 * 
 * Trägt eine IP-Adresse in die Tabelle der gesperrten Adressen ein,
 * nachdem eine ungültige Seite aufgerufen wurde.
 * error_count wird auf 4 gesetzt, damit die Sperrung sofort wirkt.
 * 
 */
global $dbh;
require_once './phpsec/createDBH.inc';
    $seite = $_SERVER['REQUEST_URI'];
    $stmt = $dbh->prepare('replace wsrDefender set IP_adresse = :IP, error_count = 4, datumUhrzeit = now(), '
        .' error_type= \'Seite ungültig\', webRequest= :seite');
    $stmt->execute(array('IP' => $_SERVER['REMOTE_ADDR'], 'seite' => $seite));
?>
blockiert.