<?php 
/**
 * Projekt: WS-Reporter
 *          Spezifikation einer Datenquelle
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    3.3.2023 ms
 *
 * Bei Aufruf ohne Einlesen einer Datenquelle wird das Verzeichnis der
 * verfügbaren Datenquellen angezeigt.
 */
include 'includes/defender.inc';

// ES FEHLT NOCH:
// initClass(): Initialisieren aus Schema-Tabellen
// import aus "Entwicklung" - statt "produktiv setzen"
global $compat0, $dbh, $importFileName, $wsReportVersion;

require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
require_once './includes/wsrTranslate.inc';
require_once './includes/qTranslate.inc';
if (session_status() == PHP_SESSION_NONE)  session_start();
anmeldungPruefen();
if (isset($_REQUEST['get']) && isValid($_REQUEST['get'])){
    header("Content-Type: text/plain; charset=UTF-8");
    adminRechteVerlangen();
    if (file_exists('includes/eqp'.$_REQUEST['get'].'.inc')) {
        if (array_key_exists('WSReportQuery', $_SESSION)){
            $query = $_SESSION['WSReportQuery'];
            session_abort();
            if (array_key_exists('table', $_REQUEST)){
                $table = $_REQUEST['table'];
                if (strcmp($query->class_table,$table) !=0){
                    http_response_code(425);
                    echo WSRTranslate::translateH('Es gibt nur einen aktiven Editor.')
                    . "\n".WSRTranslate::translateH('Jetzt').': '.$query->class_table
                    ."\n".WSRTranslate::translateH('Dieser Editor ist ungültig.');
                    die();
                }
            }
            if (array_key_exists('id', $_REQUEST)){
                if ($query->object_id != $_REQUEST['id']){
                    http_response_code(425);
                    echo WSRTranslate::translateH('Es gibt nur einen aktiven Editor.')
                    . "\n".WSRTranslate::translateH('Jetzt für Report').': '.$query->title
                    ."\n".WSRTranslate::translateH('Dieser Editor ist ungültig.');
                    die();
                }
            }
            include './includes/eqp'.$_REQUEST['get'].'.inc';
        }else{
            http_response_code (400);
            echo WSRTranslate::translateH('Die Session ist abgelaufen.');
        }
    }else{
            http_response_code (400);
            echo WSRTranslate::translateH('Ungültiger Aufruf').' '.$_REQUEST['get'];
    }
    die();    
}

if (isset($_REQUEST['set']) && isValid($_REQUEST['set'])){
    header("Content-Type: text/plain; charset=UTF-8");
    adminRechteVerlangen();
    if (file_exists('includes/eqs'.$_REQUEST['set'].'.inc')) {
        if (array_key_exists('WSReportQuery', $_SESSION)){
            $query = $_SESSION['WSReportQuery'];
            if (array_key_exists('table', $_REQUEST)){
                $table = $_REQUEST['table'];
                if (strcmp($query->class_table,$table) !=0){
                    http_response_code(425);
                    echo WSRTranslate::translateH('Es gibt nur einen aktiven Editor.')
                    . "\n".WSRTranslate::translateH('Jetzt').': '.$query->class_table
                    ."\n".WSRTranslate::translateH('Dieser Editor ist ungültig.');
                    die();
                }
            }
            if (array_key_exists('id', $_REQUEST)){
                if ($query->object_id != $_REQUEST['id']){
                    http_response_code(425);
                    echo WSRTranslate::translateH('Es gibt nur einen aktiven Editor.')
                    . "\n".WSRTranslate::translateH('Jetzt für Report').': '.$query->title
                    ."\n".WSRTranslate::translateH('Dieser Editor ist ungültig.');
                    die();
                }
            }
            include './includes/eqs'.$_REQUEST['set'].'.inc';
        }else{
            http_response_code (400);
            echo WSRTranslate::translateH('Die Session ist abgelaufen.');
        }
    }else{
        http_response_code (400);
        echo WSRTranslate::translateH('Ungültiger Aufruf').' '.$_REQUEST['set'];
    }
   
    session_write_close();
    die();
}

if (isset($_REQUEST['program']) || (isset($_REQUEST['table']) && strpos($_REQUEST['table'], '?program='))){
    header("Content-Type: text/plain; charset=UTF-8");
    http_response_code(425);
    echo "Veralteter Aufruf\n"; echo var_dump($_REQUEST);
    die;
}
/*
 * header('Content-Type: application/pdf');
 Content-Type: text/html; charset=UTF-8
// Es wird downloaded.pdf benannt
header('Content-Disposition: attachment; filename="downloaded.pdf"');
 *  header("Content-Disposition: attachment; filename=\"" . basename($filename) . "\"");
 *  
 *  
 *  
 *  
 *  http_response_code (
 *      const BAD_REQUEST = 400;
    const UNAUTHORIZED = 401;
    const PAYMENT_REQUIRED = 402;
    const FORBIDDEN = 403;
    const NOT_FOUND = 404;
    const METHOD_NOT_ALLOWED = 405;
    const NOT_ACCEPTABLE = 406;
    const PROXY_AUTHENTICATION_REQUIRED = 407;
    const REQUEST_TIMEOUT = 408;
    const CONFLICT = 408;
    const GONE = 410;
    const LENGTH_REQUIRED = 411;
    const PRECONDITION_FAILED = 412;
    const REQUEST_ENTITY_TOO_LARGE = 413;
    const REQUESTURI_TOO_LARGE = 414;
    const UNSUPPORTED_MEDIA_TYPE = 415;
    const REQUESTED_RANGE_NOT_SATISFIABLE = 416;
    const EXPECTATION_FAILED = 417;
    const IM_A_TEAPOT = 418;
WS 425


 */


?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<?php
require_once './phpsec/createDBH.inc';
require_once './includes/loadClassDef.inc';

$query = null;
$table = null;
$newQuery="";
if (isset($_REQUEST['import'])){
    adminRechteVerlangen();
    require_once './includes/importClassDef.inc';
    $importFileName = $_FILES['importFile']['name'];
    $datei = fopen($_FILES['importFile']['tmp_name'],'r');
    importClassDef($datei);
    fclose($datei);
    
    $_SESSION['WSReportQuery'] = $query;
    session_write_close();
    $table = $query->class_table;
    
}else{
    if (array_key_exists('WSReportQuery', $_SESSION)){
        $query = $_SESSION['WSReportQuery'];
    }
    
    if (array_key_exists('table', $_REQUEST)){
        $table = $_REQUEST['table'];
    }
    
    if ($table != null && ($query == null 
        || array_key_exists( 'reload',$_REQUEST)
        || strcmp($table, $query->class_table) != 0)){
        $query = new Query($table);
        loadClassDef($query);
        $_SESSION['WSReportQuery'] = $query;
        $newQuery= 'Neues Query-Objekt erzeugt<br>';
        session_write_close();
    } else  session_abort();

    
    if ($query == null || isset($_REQUEST['vrz']) || isset($_REQUEST['verzeichnis']) || isset($_REQUEST['Auswahl'])){  // Datenquellen auflisten
        $sql = new SqlAbfrage('WSR');
        $sql->sql ="select a.table_name, a.attribute as outputTitlePrefix," 
            . " b.attribute as physTable, c.attribute as tableDescription, count(*) as anzReports,"
            . " t.attribute as queryType"      
            . " from queryAttribute a"
            . " left join queryAttribute b on b.table_name = a.table_name and b.SatzTyp = 4"
            . " left join queryAttribute c on c.table_name = a.table_name and c.SatzTyp = 5"
            . " join queryAttribute t on t.table_name = a.table_name and t.SatzTyp = 10";
            
        $sql->sql .= " left join reportAttributes d on d.table_name = a.table_name";
        $sql->sql.= " where a.SatzTyp = 2 ";
        if (! $_SESSION['globalAdmin']){
            $sql->sql .= ' and a.table_name in (select table_name from wsrRechte where user = "'.$_SESSION['User'].'") ';
        }
        if (isset($_REQUEST['Auswahl'])){
            $sql->sql .= ' and t.attribute in ("X"';
            if (isset($_REQUEST['Auswahl0'])) $sql->sql .= ',"0"';
            if (isset($_REQUEST['Auswahl1'])) $sql->sql .= ',"1"'; 
            if (isset($_REQUEST['Auswahl11'])) $sql->sql .= ',"11"';
            if (isset($_REQUEST['Auswahl12'])) $sql->sql .= ',"12"';
            $sql->sql .= ') ';
        }
        $sql->firstWhere = false;
        if (isset($_REQUEST['AuswahlTable'])){
            $sql->addSel('a.table_name like', trim($_REQUEST['AuswahlTable']).'%');
        }
        if (isset($_REQUEST['AuswahlLabel'])){
            $sql->addSel('a.attribute like', trim($_REQUEST['AuswahlLabel']).'%');
        }
        
        $sql->sql .= " group by a.table_name order by a.table_name";    
        $stmt = $sql->execute();
//     error_log(print_r($sql,true));
?>
<title><?=WSRTranslate::translate('WSReporter: Liste der Datenquellen')?></title>
<meta name="GENERATOR" content="WS-PHP: editQuery.php">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="./jscss/WSReport.css" >
<script type="text/javascript" src="./jscss/tableHeader.js">
	</script>
</head>
<?php 
if ($_SERVER["HTTP_HOST"] == "localhost:8898"){
    ?>
<body class = "entwicklung">	
<?php
} else echo '<body>';
?>

<h1><?=WSRTranslate::translateH('WS-Reporter: Liste der Datenquellen')?></h1>
<div class="inlineBox">
<?php 
if (array_key_exists('Name', $_SESSION))
    echo '<b>'.WSRTranslate::translateH('Anmeldung').':</b> '.$_SESSION['Name']."<br>\n";
?>
<p><?=WSRTranslate::translateH('Bitte eine Datenquelle auswählen')?>:</p>
<form action='./editQuery.php' method='GET'>
<input type='Checkbox' name='Auswahl0' value='1'
 <?php if (array_key_exists('Auswahl0', $_REQUEST)) echo checked($_REQUEST['Auswahl0']); ?> /> <?=WSRTranslate::translate('Datenabfrage')?>
<input type='Checkbox' name='Auswahl1' value='1'
 <?php if (array_key_exists('Auswahl1', $_REQUEST)) echo checked($_REQUEST['Auswahl1']); ?> /> <?=WSRTranslate::translate('Datenerfassung')?>
<input type='Checkbox' name='Auswahl11' value='1' 
 <?php if (array_key_exists('Auswahl11', $_REQUEST)) echo checked($_REQUEST['Auswahl11']); ?> /> <?=WSRTranslate::translate('Dimension')?>
<input type='Checkbox' name='Auswahl12' value='1' 
 <?php if (array_key_exists('Auswahl12', $_REQUEST)) echo checked($_REQUEST['Auswahl12']); ?> /> <?=WSRTranslate::translate('Auswahlliste')?>
<input type='submit' value='<?=WSRTranslate::translate('Anzeigen')?>' name='Auswahl' >
<?php 
echo "\n<br><span ".makeTitleClass(WSRTranslate::translate("Textmuster mit % und _\n% wird automatisch angehängt."),'').'>'
 . WSRTranslate::translateH('Tabelle'). '</span> <input name="AuswahlTable"';
if (isset($_REQUEST['AuswahlTable'])){
   echo ' value = "'.$_REQUEST['AuswahlTable'];
}
echo '" />';
echo "\n  ".WSRTranslate::translateH('Beschreibung'). ' <input name="AuswahlLabel"';
if (isset($_REQUEST['AuswahlLabel'])){
    echo ' value = "'.$_REQUEST['AuswahlLabel'];
}
echo '" />';
?>
</form>
<br>
<table>
<thead>
<tr><th><?=WSRTranslate::translateH('Tabelle')?></th><th><?=WSRTranslate::translateH('Beschreibung')?></th>
      <th><?=WSRTranslate::translateH('Typ')?></th><th colspan="2"><?=WSRTranslate::translateH('Bearbeiten')?></th></tr>
</thead>
<?php
while ($z = $stmt->fetchObject()){
    $table = $z->table_name;
    $tdesc = $z->tableDescription;
    if (isValid($tdesc)) $tdesc = "\n".$tdesc;
    else $tdesc = "";
    $physTable = $z->physTable;
    if (isValid($physTable)) $physTable = WSRTranslate::translate('Phys. Tabelle').': '.$physTable;
    else $physTable =  WSRTranslate::translate('Phys. Tabelle: NICHT GEFUNDEN');
?>
<tr><th class="left" <?=makeTitle($physTable.$tdesc) ?>><?=$table ?></th>
	<td <?=makeTitle($physTable.$tdesc) ?>> <?=qTranslate::translate($z->outputTitlePrefix) ?></td>
	<td><?= Query::getTypeText($z->queryType) ?></td>
<?php
if ($_SESSION['globalAdmin']){
?>	
 	<td><a href="editQuery.php?table=<?=$table ?>" target="QueryEditor"><?=WSRTranslate::translateH('Datenquelle')?></a></td>
<?php
}else{
?>	
 	<td><a href="reportClassDef.php?table=<?=$table ?>" target="QueryDok"><?=WSRTranslate::translateH('Datenquelle')?></a></td>
<?php
}
?>	
 <td><a href="./editReport.php?table=<?=$table ?>&action=start"  target="ReportEditor"><?=WSRTranslate::translateH('Reports')?></a> (<?= $z->anzReports ?>)</td>
</tr>

<?php 
   }
?>    
</table>
<br><br>
<?php 
if ($_SESSION['globalAdmin']){  
?>
<?=WSRTranslate::translateH('Namen für eine neue Datenquelle eingeben')?>:
<form action="<?=$_SERVER['SCRIPT_NAME']?>" method = "GET"  target="QueryEditor">
	<input type = "text" name="table" value="" size="30" />
	<input type = "submit" value="<?=WSRTranslate::translate('Sepzifikation neu anlegen')?>"/>
</form>
<br><br>

<form action="<?=$_SERVER['SCRIPT_NAME']?>" method="post" enctype="multipart/form-data" target="QueryEditor">
<?=WSRTranslate::translateH('Datenquelle importieren')?>: <input type="file" name="importFile"/>
<input type="hidden" name="import" value="X"/>
 <input type="submit" name="submit" value="<?=WSRTranslate::translate('Datei importieren')?>" />
</form><br>
<form action="./editReport.php" method="post" enctype="multipart/form-data" target="ReportEditor">
<?=WSRTranslate::translateH('Report importieren')?>: <input type="file" name="importFile"/>
<input type="hidden" name="import" value="X"/>
 <input type="submit" name="submit" value="<?=WSRTranslate::translate('Datei importieren')?>" />
</form><br>
<form action="./importTranslation.php" method="post" enctype="multipart/form-data" target="Translation">
<?=WSRTranslate::translateH('Übersetzungen importieren')?>: <input type="file" name="importFile[]" multiple />
<input type="hidden" name="import" value="X"/>
 <input type="submit" name="submit" value="<?=WSRTranslate::translate('Datei importieren')?>" />
</form>
<?php }?>
</div>

<footer class="leiste">
<div class="Fleft"><?=WSRTranslate::translateH('WS Reporter Version')?> <?=$wsReportVersion ?></div>
<div class="Fright right">&copy; WS Unternehmensberatung</div>
</footer>
</body>
</html>

<?php 
        
      return;
    } // ENDE Datenquellen auflisten
}  // if not importClassDef
?>
<title><?=WSRTranslate::translate('WSReporter: Spezifikation der Datenquelle')?> <?=$query->class_table ?></title>
<meta name="GENERATOR" content="WS-PHP: editQuery.php">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="./jscss/WSReport.css" >
<?php 
if (!array_key_exists('globalAdmin', $_SESSION) ||  !$_SESSION['globalAdmin'] ){  
?>
</head>
<body>
<?=WSRTranslate::translateH('Dieser Aufruf ist nur für Administratoren zugelassen.')?><br><br>
<a href="./index.php"><?=WSRTranslate::translateH('zur Anmeldung')?></a>
</body></html>
<?php 
die();
}
?>
<script type="text/javascript" src="./jscss/tableHeader.js">
	</script>
<script type="text/javascript">
var call = "<?=$_SERVER['SCRIPT_NAME']?>?id=<?=$query->object_id?>&table=<?=$query->class_table?>";
console.log("Call="+call);
var requestID = "<?=$query->object_id?>";
var requestTable = "<?=$query->class_table?>";
	</script>
	
<script type="text/javascript" src="./jscss/WSReportMaster.js">
	</script>
<script type="text/javascript" >
window.addEventListener('load', function() {
<?php 
if (isset($_REQUEST['import'])){
    require_once './phpsec/createDBH.inc';
    $stmt = $dbh->prepare("select * from queryAttribute where table_name = :table and SatzTyp = 4");
    if ($stmt === false){
        echo "FEHLER bei prepare für Import / Suche nach gleichnamiger Definition\n";
        echo $dbh->errorInfo()[2];
    }
    $res = $stmt->execute(array('table' => $query->class_table));
    if ($res === false){
        echo "FEHLER bei Import / Suche nach gleichnamiger Definition\n";
        echo $stmt->errorInfo()[2];
    }
    if ($z = $stmt->fetchObject()){
        ?>
		alert("<?=WSRTranslate::translate('Neue Datenquelle').' '.$query->class_table
    	 ."\\n".WSRTranslate::translate('wurde aus der Datei').' '.$importFileName.' '.WSRTranslate::translate('importiert.')
         ."\\n".WSRTranslate::translate('ACHTUNG: Die Datenquelle wurde noch NICHT gespeichert!')
         ."\\n".WSRTranslate::translate('Sie muss hier zuerst geprüft werden.')
         ."\\n\\n".WSRTranslate::translate('Es existiert bereits eine Datenquelle gleichen Namens')
         ."\\n".WSRTranslate::translate('für die Datenbank-Tabelle').' '.$z->attribute?>");	
<?php 
    }else{
?>
alert("<?=WSRTranslate::translate('Neue Datenquelle').' '.$query->class_table
   	 ."\\n".WSRTranslate::translate('wurde aus der Datei').' '.$importFileName.' '.WSRTranslate::translate('importiert.')
        ."\\n".WSRTranslate::translate('ACHTUNG: Die Datenquelle wurde noch NICHT gespeichert!')
        ."\\n".WSRTranslate::translate('Sie muss hier zuerst geprüft werden.')?>");
	
<?php 
    }
    /*
     * @todo: Umstellen auf neues Report-Format
     */
/** Auf neues Report-Format umstellen    
    $sql = new SqlAbfrage('WSR');
    $sql->sql = 'select  distinct t.reportDef7 as Datenquelle,
s.reportDef1 as Spalte
from reportDefinitionen t
 left join reportDefinitionen s on s.reportTitle = t.reportTitle 
  and (s.SatzTyp between 1 and 4 ) ';
$sql->addSel('t.reportDef7 = ', $query->class_table);
$sql->sql .= ' and t.satztyp = 0 and substr(s.reportDef1,2,1) not in (":","=")
order by Datenquelle, Spalte';

$stmt = $sql->execute();
*/

/* Test auf fehlende Variablen */
$sql = 'select distinct  s.name, s.typ  from (';
$sql .= <<<EOS
    select 'Zeile/Spalte' as typ, r.column_name as name, r.reportID from reportRows r
      where r.reportID in (select reportID from reportAttributes
                           where table_name = :table1)
        and r.column_name not in (select column_name from queryColumnMetadata
                                 where table_name = :table2 and SpaltenTyp = 1)
    union
    select 'Zeile/Spalte' as typ, c.column_name as name, c.reportID from reportColumns c
      where c.reportID in (select reportID from reportAttributes
                           where table_name = :table3)
        and c.column_name not in (select column_name from queryColumnMetadata
                                 where table_name = :table4 and SpaltenTyp = 1)
    union
    select 'Wert' as typ, v.column_name as name, v.reportID from reportValues v
      where v.reportID in (select reportID from reportAttributes
                           where table_name = :table5)
        and v.wfFunction = 0 
        and v.column_name not in (select column_name from queryColumnMetadata
                                 where table_name = :table6 and SpaltenTyp = 2)
    union
    select 'Wert' as typ, vc.val_name as name, vc.reportID from reportColumns vc
      where vc.reportID in (select reportID from reportAttributes
                           where table_name = :table7)
        and vc.val_name not in (select column_name from queryColumnMetadata
                                 where table_name = :table8 and SpaltenTyp = 2)
    union
    select 'Filter' as typ, f.column_name as name, f.reportID from reportFilters f
      where f.reportID in (select reportID from reportAttributes
                           where table_name = :table9)
        and f.column_name not in (select column_name from queryColumnMetadata
                                 where table_name = :table10 and qFilterTyp > 0)
    union
    select 'Filter' as typ, fc.filter as name, fc.reportID from reportColumns fc
      where fc.reportID in (select reportID from reportAttributes
                           where table_name = :table11)
        and fc.filter not in (select column_name from queryColumnMetadata
                                 where table_name = :table12 and qFilterTyp > 0)
    union
    select 'Wert' as typ, v.wfValue as name, v.reportID from reportValues v
      where v.reportID in (select reportID from reportAttributes
                           where table_name = :table13)
        and v.wfFunction > 0 
        and v.wfValue not in (select column_name from queryColumnMetadata
                                 where table_name = :table14 and SpaltenTyp = 2)
    ) s
    
    where substring(s.name,2,1) not in (':','=')
    and s.name not like "#webLink%"
    and s.name not like "#window%"
    and s.name not like "WSR_WINDOWVALUE%"
    order by name, typ
EOS;
    $par = array();
    for ($i=1; $i <= 14; $i++) {
        $par['table'.$i] = $query->class_table;
    }
    
    $stmt = $dbh->prepare($sql);
    if ($stmt === false){
        $qerg = false;
        $stmt = $dbh;
    }else{
        $qerg = $stmt->execute($par);
    }
    
$esFehlen = '';

if ($qerg !== false){
    while ($z = $stmt->fetchObject()){
         $esFehlen .= '+"\n'.$z->name.' ('.$z->typ.')"';        
    }
}else{
    ?>
    alert("<?=WSRTranslate::translate('Fehler in der SQL')?>\n<?=$stmt->errorInfo()[2] ?>");	    
<?php 
}
if (strlen($esFehlen) > 0) {
?>    
    alert("<?=WSRTranslate::translate('FEHLER folgende Variablen aus definierten Reports')?>\n"
   +"<?=WSRTranslate::translate('fehlen in der importierten Datenquelle')?>" <?=$esFehlen?>);
<?php     
}

} // Ende Import ClassDef
if ($_SERVER["HTTP_HOST"] == "localhost:8898"){
    ?>
    var body = document.getElementsByTagName('body')[0];
    body.className = "entwicklung";
	
<?php 
}
?> 	
  });
</script>
</head>
<body>
<h1><?=WSRTranslate::translateH('Spezifikation der Datenquelle')?></h1>
<h2><?=$query->class_table ?></h2>

<?php
echo $newQuery;
if (array_key_exists('Name', $_SESSION))
    echo '<b>'.WSRTranslate::translateH('Anmeldung').':</b> '.$_SESSION['Name']."<br>\n";
?>

<div id="Editor" class = "editorBox"><?=WSRTranslate::translateH('Editor für Metadaten einer Variablen')?></div>
<div id="SelectWerte" class = "editorBox"><?=WSRTranslate::translateH('Editor für Select-Werte einer Variablen')?></div>
<div id="QueryEditor" class = "editorBox"><?=WSRTranslate::translateH('Editor für zusätzliche Tabellen (Joins)')?></div>
<div id="JoinWerte" class = "joinWerteBox"><h3><?=WSRTranslate::translateH('Werte-Auswahl aus Join-Tabelle')?>
   <div class="xButton" onclick="closeJoinWerte()" title="<?=WSRTranslate::translate('schließen')?>">&otimes;</div>
</h3>
<div id="JoinWerteTable"></div>
</div>



<div class="inlineBox">
<h3><?=WSRTranslate::translateH('Globale Eigenschaften').anleitung('2','dqGlobal') ?></h3>
<div id="Globals">
<?php include './includes/eqpGlobals.inc';?>
<!--  ENDE Globals -->
</div>
</div>
<br>

<div class="inlineBox">
<h3><?=WSRTranslate::translateH('Zeilen').anleitung('2','dqZeilen') ?></h3>
<div id="SpezZeilen">
<?php include './includes/eqpZeilen.inc';?>
<!--  ENDE Zeilen -->
</div>
</div>
<?php 
if ($query->queryType < Query::DIMENSION){
?>
<br>
<div class="inlineBox"><h3><?=WSRTranslate::translateH('Werte').anleitung('2','dqWerte') ?></h3>
<div id="SpezWerte">
<?php include './includes/eqpWerte.inc';?>
<!--  ENDE Werte -->
</div>
</div>
<br>
<?php 
}
?>
<div class="inlineBox"><h3><?=WSRTranslate::translateH('Filter').anleitung('2','dqFilter') ?></h3>
<div id="SpezFilter">
<?php include './includes/eqpFilter.inc';?>
<!--  ENDE Filter -->
</div>
</div>
<?php 
if ($query->queryType < Query::DIMENSION){
?>
<br>
<div class="inlineBox"><h3><?=WSRTranslate::translateH('Default-Filter').anleitung('2','dqDefaultFilter') ?></h3>
<div id="SpezDefaultFilter">
<?php include './includes/eqpDefaultFilter.inc';?>
<!--  ENDE Default-Filter -->
</div>
</div>
<?php 
}
?>

<br>

<?php 
if ($query->queryType != Query::DIMENSION){
?>
<div class="inlineBox">
<h3><?=WSRTranslate::translateH('Verknüpfte Dimensionen').anleitung('2','dqDimensionen') ?></h3>
<div id="SpezDimensionen">
<?php include './includes/eqpDimensionen.inc';?>

<!--  ENDE AddQueries -->

</div>
</div>
<br>
<?php
}
if ($query->queryType < Query::DIMENSION){
?>

<div class="inlineBox">
<h3><?=WSRTranslate::translateH('Zusätzliche Datenquellen zum Verknüpfen').anleitung('2','dqJoins') ?></h3>
<div id="SpezAddQuery">
<?php include './includes/eqpAddQuery.inc';?>

<!--  ENDE AddQueries -->

</div>
</div>



<?php 
}
?>
<footer class="" id="footLong">
<br>
<div class="leiste nowrap">
<div class="Fleft" onclick="hideFoot()">
<span class="clickFlaeche">&lt;&lt;</span></div>
<div class="Fcenter nowrap">
<form method="POST" name="saveForm" id="saveForm" action="<?=$_SERVER['SCRIPT_NAME']?>" class="inline" >
	<input type="hidden"  name ="table" value="<?=$query->class_table?>" />
	<input type="hidden"  name ="set" value="QueryActions" />
	<input type="hidden"  name ="action" value="" />
<?php 
if (substr($query->currentLanguage,0,2) == $query->qLanguage){
?>	
	<input type="button" id="save1" name="speichern" onclick="saveClass(true);" 
		value="<?=WSRTranslate::translate('Speichern und beenden')?>" />
	<input type="button" name="speichernOhneBeenden" onclick="saveClass(false);" 
		value="<?=WSRTranslate::translate('Speichern ohne beenden')?>" />
<?php 
}
?>
	
<select id="befehl" title="<?=WSRTranslate::translate('Weitere Aktionen')?>">
    <option value="deleteClass" class="warn"><?=WSRTranslate::translate('löschen')?></option>
    <option value="reportClass" ><?=WSRTranslate::translate('dokumentieren')?></option>
<?php 
if (($_SESSION['globalAdmin'] || $_SESSION['uebersetzer'])   // Der gesamte Editor funktioniert doch nur mit globalAdmin ???
//    && $query->qLanguage == substr($_SESSION['Sprache'], 0,2)
    ){
?> 
    <option value="translateClass" ><?=WSRTranslate::translate('übersetzen')?></option>
<?php 
}
?>      
    <option value="testClass" selected><?=WSRTranslate::translate('testen')?></option>
    <option value="testClassE"><?=WSRTranslate::translate('Elemente testen')?></option>
    <option value="testSql"><?=WSRTranslate::translate('Test-SQL ausgeben')?></option>
    <option value="testReports" title="<?=WSRTranslate::translate('Prüfe Kompatibilität mit existerenden Reports')?>"
    	><?=WSRTranslate::translate('Reports prüfen')?></option>
<?php if ($query->queryType == Query::DIMENSION) {?>    
    <option value="showDimUse" title="<?=WSRTranslate::translate('Verwendung der Dimension in anderen Datenquellen zeigen.
Aus dieser Anzeige können die Datenquellen zur Bearbeitung aufgerufen
und aktualisiert werden.')?>"><?=WSRTranslate::translate('Verwendungen anzeigen')?></option>
<?php  } ?>    
    <option value="exportClass"><?=WSRTranslate::translate('exportieren')?></option>
<?php 
if ($_SESSION['globalAdmin']){
?> 

<?php 
}
if (count($query->rowVars) <= 0 
	|| count($query->valueVars) <= 0){
?> 
  <option value="initClass" selected><?=WSRTranslate::translate('initialisieren')?></option>
<?php  } ?>
    </select>
    <input type="button" id= "befehlAusführen" value="<?=WSRTranslate::translate('ausführen')?>" onclick="befehlAusfuehren()"/>
    
    <input type="button" id= "Anleitung" value="<?=WSRTranslate::translate('Anleitung')?>" onclick="anleitung('12','datenquellen')"/>
    
</form>
</div>
<div class ="Fright">&nbsp;</div>
</div>

<div class="leiste">
<div class="Fleft"><?=WSRTranslate::translateH('WS Reporter Version')?> <?=$wsReportVersion?></div>
<div class="Fright">&copy; WS Unternehmensberatung</div>
</div>
</footer>
<footer  id="footShort" class="hidden" width="min-content" >
<div onclick="showFoot()"  ><span class="clickFlaeche">&gt;&gt;</span></div>
</footer>
</body>
</html>