<?php
/**
 * Projekt: WS-Reporter
 *          Ausgabe der Zusatz-Filter im Report-Editor
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    22.02.2023 MS
 *
 */

global $query;
require_once './includes/enterFilterSpec.inc';
require_once './includes/wsrTranslate.inc';

    $dFilter = $query->defaultFilter;
        for ($i = 0; $i < count($dFilter); $i++){
            $filter = $dFilter[$i];
            if ($filter == null) {
                error_log("Leerer Default-Filter an Position $i");
                continue;
            }
            $metaRecord = $query->metaData[$filter->column_name];
            if ($metaRecord == null
                || $metaRecord->filterType <= MetaRecord::NONE) 
                    $label = WSRTranslate::translate('FEHLER: Keine Metadaten für')." ".$filter->column_name;
            else $label = $metaRecord->label;
            ?>
            <div class="nowrap" >
            <b <?=makeTitleClass($metaRecord->description,'') ?>><?=$filter->column_name.': '.$label?></b>
            <?php
            enterFilterSpec('DefaultFilter', $i,$filter->column_name, $filter->fs_von, $filter->fs_bis);
            ?>
           &nbsp;&nbsp;
            <div class="nowrap right">
            <img src="./icons/delete.png" alt="<?=WSRTranslate::translate('löschen')?>" 
            title="<?=WSRTranslate::translate('Zeile löschen')?>" class="icon" onclick="delVar(6,<?=$i ?>)" />
            </div>
            </div><br>
            <?php
            
        }
   
    ?>
    
  <hr>
<div class="nowrap"><?=WSRTranslate::translateH('hinzufügen')?>:
<select name="selAddDefaultFilter" id='NV6' onchange="newVar(6,this)">
<option value="--" selected >--</option>
<?php
for ($i=0; $i < count($query->rowVars); $i++){
    $rfn = $query->rowVars[$i];
    if (array_key_exists($rfn, $query->defaultFilter)) continue;
    $mr = $query->metaData[$rfn];
    if ($mr->filterType == MetaRecord::LIST) continue;
    if ($mr->filterType == MetaRecord::NONE) continue;
    $skip = false;
    for ($j = 0; $j < count($query->defaultFilter); $j++)
        if ($query->defaultFilter[$j]->column_name == $rfn) $skip = true;
    if (! $skip){
?>
<option value="<?=$rfn ?>" ><?=$rfn.': '.$mr->label?></option>

<?php
    }
}
for ($i=0; $i < count($query->filterVars); $i++){
    $rfn = $query->filterVars[$i];
    if (array_key_exists($rfn, $query->defaultFilter)) continue;
    $mr = $query->metaData[$rfn];
    if ($mr->filterType == MetaRecord::LIST) continue;
    $skip = false;
    for ($j = 0; $j < count($query->defaultFilter); $j++)
        if ($query->defaultFilter[$j]->column_name == $rfn) $skip = true;
    if (! $skip){
            ?>
<option value="<?=$rfn ?>" ><?=$rfn.': '.$mr->label?></option>

<?php
    }
}
?>
</select>

</div>


