<?php
/**
 * Projekt: WS-Reporter
 *          Anzeige der Metadaten (Spalte, Wert, Filter) bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    21.2.2023 MS
 *
 */
require_once './includes/wsrTranslate.inc';

global $query;

if ($query->qEditSubject < 1 || $query->qEditSubject > 3){
    http_response_code(425);
    echo "Ungültiger Aufruf qEditSubject = $query->qEditSubject\n";
    echo var_dump($_REQUEST);
    return;
}
if (!isValid($query->qEditVar)){
    http_response_code(425);
    echo "Ungültiger Aufruf qEditVar = $query->qEditVar\n";
    echo var_dump($_REQUEST);
    return;
}
$wo = $query->qEditSubject;
$column_name = $query->qEditVar;
$mr = $query->metaData[$column_name];
if ($mr == null){
    http_response_code(425);
    echo "Ungültiger Aufruf keine Metadaten für qEditVar = $query->qEditVar\n";
    echo var_dump($_REQUEST);
    return;
}
if (false) $mr = new MetaRecord();
?>
 <div class="xButton" onclick="closeEditor()" title="<?=WSRTranslate::translate('schließen')?>">&otimes;</div>
 <h3><span onclick="renameStart()"><?=WSRTranslate::translateH('Metadaten für').' '.$column_name ?></span><?=anleitung('2','dqMeta1') ?></h3>
 <form   id="editorForm" onsubmit="return false;"> 
 <input type="hidden" name="program" value="saveMetaData"/>
 <input type="hidden" name="name" value="<?=$column_name?>"/>
 <input type="hidden" name="warwo" value="<?=$wo?>"/>
 
 <table>
 <tr id="renameRow"><td><?=WSRTranslate::translateH('umbenennen')?>:</td><td>
 <input value="<?=$column_name ?>" name="newName"/>
 <button onclick="setMetaAttrib('rename',forms.editorForm.newName.value);loadNrF(11);loadNrF(<?=$wo ?>)"
 	><?=WSRTranslate::translate('umbenennen')?></button>
 <button value="abortRename" onclick="renameClose()"><?=WSRTranslate::translate('abbrechen')?></button>
 </td></tr>
 <tr><td><?=WSRTranslate::translateH('Wo')?>:</td><td>
 <select name="wo" id="wo" onchange="umhaengen(this.value)" >
 <option value="1" <?=checkSel("1",$wo) ?>><?=WSRTranslate::translate('Zeilen')?></option>
 <option value="2" <?=checkSel("2",$wo) ?>><?=WSRTranslate::translate('Werte')?></option>
 <option value="3" <?=checkSel("3",$wo) ?>><?=WSRTranslate::translate('Filter')?></option>
 </select>
 
 <?php 
 if ($wo == 2 && $query->queryType > 0){
 ?>
 <input type="checkbox" onclick="setMetaAttrib('enterValue',this.checked);loadNrF(11)"  <?=checked($mr->enterValue)?> 
 />&nbsp;<?=WSRTranslate::translateH('Eingabefeld')?>
 <?php 
}
?>
<input type="checkbox" <?=checked($mr->hidden)?>
  onchange="setMetaAttrib('setHidden',this.checked)" ><span 
  class="help" title="<?=WSRTranslate::translate('Verbergen in der Report-Definition')?>">&nbsp;<?=WSRTranslate::translateH('verbergen')?></span>
 
 
 </td></tr>

 <tr><td class="help" title="<?=WSRTranslate::translate('Sonderzeichen')?>:
 &amp;sum = &sum;
 &amp;Oslash = &Oslash;
 &amp;uArr = &uArr;
 &amp;dArr = &dArr;
 &amp;permil = &permil;
 &amp;otimes = &otimes;
 "><?=WSRTranslate::translateH('Label')?>:</td><td><input type="text" name ="label" value="<?=quoteForText($mr->label) ?>" 
  onchange="setMetaAttrib('label',this.value)" size="50"   autocomplete="off" /></td></tr>
<tr><td class="help" title="<?=WSRTranslate::translate('Sonderzeichen')?>:
 &amp;sum = &sum;
 &amp;Oslash = &Oslash;
 &amp;uArr = &uArr;
 &amp;dArr = &dArr;
 &amp;permil = &permil;
 &amp;otimes = &otimes;
 "><?=WSRTranslate::translateH('Beschreibung')?>:</td><td>
<textarea rows="5" cols="60" autocomplete="off" name="description" onchange="setMetaAttrib('description',this.value)"
><?=quoteForText($mr->description) ?>
</textarea>
</td></tr>
<tr><td class="help" ><?=WSRTranslate::translateH('Technische Hinweise')?>:</td><td>
<textarea rows="5" cols="60" autocomplete="off" name="Hints" onchange="setMetaAttrib('hints',this.value)"
><?=quoteForText($mr->hints) ?>
</textarea>
</td></tr>
 <tr><td class="help" 
 title="<?=WSRTranslate::translate('Ganze Zahlen erhalten keine Tausender-Punkte.
 Ganze Zahlen mit Tausender-Punkten sind Dezimalzahlen
 ohne Nachkommastellen.
 Hier ist der Typ des Select-Ausdrucks anzugeben.
 Der Anzeige-Ausdruck wird immer als Text behandelt')?>." ><?=WSRTranslate::translateH('Typ')?>:</td><td>
  <select name="type" onchange="setMetaAttrib('type',this.value)">
<?php 
foreach (MetaRecord::klartextType as $type => $text){
    if ($type < 20 
        || ($query->histType == Query::VONBIS &&
            ($type == MetaRecord::HISTAB || $type == MetaRecord::HISTBIS)
            )
        || (($query->histType == Query::VONBIS
            || ($mr->dimNr > 0 && $query->dimensions[$mr->dimNr]->histType == Query::VONBIS) 
            ) && $type == MetaRecord::HISTDEL
            )
        
        || ($type == MetaRecord::HISTSTICHTAG)            
        )
        echo '<option value="'.$type.'" '.checkSel($type,$mr->type).' >'.WSRTranslate::translate($text)."</option>\n";        
}
?>  
 </select>
 <?php 
 if ($mr->enterValue){
 ?>
 <?=WSRTranslate::translateH('Größe')?>: 
 <input type="text" name="enterValueSize" value="<?=$mr->enterValueSize ?>" size="5"  
 onchange="setMetaAttrib('enterValueSize',this.value)" autocomplete="off" />
 <?php 
 }
 ?>
 </td></tr>
 <?php
 if ($wo != 3){
 ?>
 <tr><td>HTML-Tag:</td><td><input type="text" name="htmlData" value="<?=$mr->htmlData ?>" size="10"   autocomplete="off" 
 onchange="setMetaAttrib('htmlData',this.value)"/></td></tr>
 <tr><td><?=WSRTranslate::translateH('Ausrichtung')?>:</td><td>
  <select name="align" onchange="setMetaAttrib('align',this.value)">
 <option value="left" <?=checkSel("left",$mr->align) ?>><?=WSRTranslate::translate('links')?></option>
 <option value="right" <?=checkSel("right",$mr->align) ?>><?=WSRTranslate::translate('rechts')?></option>
 <option value="center" <?=checkSel("center",$mr->align) ?>><?=WSRTranslate::translate('zentriert')?></option>
</select> 
 </td></tr>
 <?php 
 }
 ?>
 <tr><td><?=WSRTranslate::translateH('Nachkommastellen')?>:</td><td><input type="number" name="decimals" value="<?=$mr->decimals ?>" size="10" 
 onchange="setMetaAttrib('decimals',this.value)"  autocomplete="off" /></td></tr>

 <tr  id="WSel"><td class="help left"	title="<?=WSRTranslate::translate('Tipps: 
 ifnull(join.wert,0) verwenden, wenn mit NULL-Werten als 0 gerechnet werden soll.
 if(bool,wert1,wert2) ist Alternative zu case when bool then wert1 else wert2 end.')?>"
 ><?=WSRTranslate::translateH('Select-Name oder Ausdruck')?>:</td><td>

<?php 
if (strlen($mr->selectVar) < 50){    
?> 
 <input type="text" name="selectVar" value="<?=quoteForText(blankAsNull($mr->selectVar)) ?>" size="50"  
 onchange="setMetaAttrib('selectVar',this.value)" autocomplete="off" />
<?php 
}else{
?>
  <textarea rows="2" cols="60" autocomplete="off" onchange="setMetaAttrib('selectVar',this.value)"
  ><?=quoteForText(blankAsNull($mr->selectVar)) ?>
 </textarea>
 
 <?php
}
echo "</td></tr>\n";

 if ($wo == 1 
     || $wo == 3      
     || isValid($mr->displayVar)){
?>
<tr id="WAnz"><td  class="help left"	title="<?=WSRTranslate::translate('Tipps: 
 concat(text1,..) verknüpft Texte, liefert NULL, wenn 1 Text NULL.
 concat_ws(trennzeichen,text1..) verknüpft Texte mit Trennzeichen und ignoriert NULLs.')?>"
 ><?=WSRTranslate::translateH('Select für Anzeige')?>:</td><td> 
<?php      
     if (strlen($mr->displayVar) < 50){
 ?>
 <input type="text" name="displayVar" value="<?=quoteForText(blankAsNull($mr->displayVar)) ?>" size="50"   
 onchange="setMetaAttrib('displayVar',this.value)" autocomplete="off" />
 <?php
         }else{
?>             
     <textarea rows="2" cols="60" autocomplete="off" onchange="setMetaAttrib('displayVar',this.value)"
     ><?=quoteForText(blankAsNull($mr->displayVar)) ?>
</textarea>

<?php 
         }
         echo "</td></tr>\n";
 } 
 
  if ($wo == 2 && $query->queryType > 0 && $mr->enterValue){
 ?>
 <tr id="WEing"><td><?=WSRTranslate::translateH('Name für Eingabe')?></td><td>
 <input type="text" name="setVarname" value="<?=quoteForText(blankAsNull($mr->qSetVarname)) ?>" size="30"   
 onchange="setMetaAttrib('qSetVarname',this.value)" autocomplete="off" /></td></tr>
 <?php } ?>
 
 <tr><td><?=WSRTranslate::translateH('Filter-Typ')?>:</td><td>
  <select name="filterType" onchange="setMetaAttrib('filterType',this.value);setFilterAnzeige()" >
 <option value="<?=MetaRecord::NONE ?>" <?=checkSel(MetaRecord::NONE,$mr->filterType) ?>><?=WSRTranslate::translate('kein Filter')?></opttion>
 <?php if ($mr->type == MetaRecord::HISTDEL) { ?>
 <option value="<?=MetaRecord::HISTDEL ?>" <?=checkSel(MetaRecord::HISTDEL,$mr->filterType) ?>><?=WSRTranslate::translate('Std.-Filter')?></opttion>
 <option value="<?=MetaRecord::VON_BIS ?>" <?=checkSel(MetaRecord::VON_BIS,$mr->filterType) ?>><?=WSRTranslate::translate('von bis')?></opttion>
 <option value="<?=MetaRecord::VON_BIS_SELECT ?>" <?=checkSel(MetaRecord::VON_BIS_SELECT,$mr->filterType) ?>><?=WSRTranslate::translate('Auswahl von bis')?></opttion>
 <?php } else { ?>
 <option value="<?=MetaRecord::TEXT ?>" <?=checkSel(MetaRecord::TEXT,$mr->filterType) ?>><?=WSRTranslate::translate('Text (enthält)')?></opttion>
 <option value="<?=MetaRecord::TEXTLIKE ?>" <?=checkSel(MetaRecord::TEXTLIKE,$mr->filterType) ?>><?=WSRTranslate::translate('Text-Muster')?></opttion>
 <option value="<?=MetaRecord::TEXTEXAKT ?>" <?=checkSel(MetaRecord::TEXTEXAKT,$mr->filterType) ?>><?=WSRTranslate::translate('Text genau')?></opttion>
 <option value="<?=MetaRecord::TEXTMITLABEL ?>" <?=checkSel(MetaRecord::TEXTMITLABEL,$mr->filterType) ?>><?=WSRTranslate::translate('Text mit Label')?></opttion>
 <option value="<?=MetaRecord::SELECT ?>" <?=checkSel(MetaRecord::SELECT,$mr->filterType) ?>><?=WSRTranslate::translate('Auswahl')?></opttion>
 <option value="<?=MetaRecord::LIST ?>" <?=checkSel(MetaRecord::LIST,$mr->filterType) ?>><?=WSRTranslate::translate('Liste')?></opttion>
 <option value="<?=MetaRecord::VON_BIS ?>" <?=checkSel(MetaRecord::VON_BIS,$mr->filterType) ?>><?=WSRTranslate::translate('von bis')?></opttion>
 <option value="<?=MetaRecord::VON_BIS_SELECT ?>" <?=checkSel(MetaRecord::VON_BIS_SELECT,$mr->filterType) ?>><?=WSRTranslate::translate('Auswahl von bis')?></opttion>
 <option value="<?=MetaRecord::SONDERFILTER ?>" <?=checkSel(MetaRecord::SONDERFILTER,$mr->filterType) ?>><?=WSRTranslate::translate('Sonderfilter')?></opttion>
 <option value="<?=MetaRecord::SONDERFILTERSEL ?>" <?=checkSel(MetaRecord::SONDERFILTERSEL,$mr->filterType) ?>><?=WSRTranslate::translate('Sonderfilter mit Auswahl')?></opttion>
 <?php }?>
 </select> 
 <span id="FReq">
 <input type="button" onclick="enterSelectOptions()" id="SO" value ="<?=WSRTranslate::translate('Optionen eingeben')?>" 
 />&nbsp;<?=WSRTranslate::translate('Filter')?>&nbsp;<?=WSRTranslate::translate('erforderlich')?>:&nbsp;<select 
 onchange="setMetaAttrib('filterRequiredGroup',this.value)" >
 <option value="0" <?=checkSel(0,$mr->filterRequiredGroup) ?>><?=WSRTranslate::translate('nicht erforderlich')?></option>
 <?php 
 for ($i = 1; $i < 10; $i++){
     echo "<option value=\"$i\" ".checkSel($i,$mr->filterRequiredGroup).">".WSRTranslate::translate('in Gruppe')." {$i}</option>\n";
 }
 ?>
 </select></span>
 </td></tr>
 <tr id="WT"><td
<?php
if ($mr->filterType == MetaRecord::LIST){
?> 
class="help"	title="<?=WSRTranslate::translate('Wenn leer, wird die Basistabelle mit allen
anderen Filtereinstellungen der Report-Anforderung verwendet.
ansonsten entspricht die Behandlung der Liste beim filter-Typ Auswahl.')?>" 
<?php
}else{
    ?>
class="help"	title="<?=WSRTranslate::translate('Physischer Name einer DB-Tabelle oder eines DB-Views, 
\'#\' für die aktuelle Tabelle oder Dimension
\'#Datenquelle\' für eine Dimension oder Auswahlliste.')?>" 
    <?php    
}
?> 
 ><?=WSRTranslate::translateH('Werte-Tabelle')?>:</td><td>
 <input type="text" name="selectFilterTable" value="<?=blankAsNull($mr->selectFilterTable) ?>" size="30"   autocomplete="off"
 	 onchange="setMetaAttrib('selectFilterTable',this.value);setFilterAnzeige()" />
 	 Sort.: <select  name="filterSort" onchange="setMetaAttrib('filterSort',this.value)" >
<?php
foreach (Sort::klartext as $sn => $st){
    if ($sn > 0)
        echo  '<option value="'.$sn.'" '.checkSel($sn,$mr->filterSort).' >'.WSRTranslate::translate($st)."</option>\n";
}
?> 	 
 	 </select>
 	 </td></tr>
<?php 
if (isValid($mr->selectFilterTable) && substr($mr->selectFilterTable, 0,1) != '#'){
?> 	 
 <tr id="WS"><td class="help" 
 title="<?=WSRTranslate::translate('Hier wird der Name eines Filters angegeben.
 Der Filter selbst wird dann wie bei der Daten-Abfrage
 über die selectVar im Metarecord erstellt.')?>"><?=WSRTranslate::translateH('Filter-Spalte')?> 1:</td><td>
  <input type="text" name="selectFilterVar" value="<?=blankAsNull($mr->selectFilterVar) ?>" size="30"  
  onchange="setMetaAttrib('selectFilterVar',this.value)" autocomplete="off" /></td></tr>
 <tr id="WT2"><td><?=WSRTranslate::translateH('Zweite Werte-Tabelle zum Eingrenzen')?>:</td><td>
  <input type="text" name="selectFilterTable2" value="<?=blankAsNull($mr->selectFilterTable2) ?>" size="30"   
  onchange="setMetaAttrib('selectFilterTable2',this.value)" autocomplete="off" /></td></tr>
  <tr id="WS2" ><td class="help" 
 title="<?=WSRTranslate::translate('Hier wird der Name eines Filters angegeben.
 Der Filter selbst wird dann wie bei der Daten-Abfrage
 über die selectVar im Metarecord erstellt.')?>"><?=WSRTranslate::translateH('Filter-Spalte für zweite Werte-Tabelle')?>:</td><td>
  <input type="text" name="selectFilterVar2" value="<?=blankAsNull($mr->selectFilterVar2) ?>" size="30" 
  onchange="setMetaAttrib('selectFilterVar2',this.value)"   autocomplete="off" /></td></tr>
 
<?php
}
if ($mr->dimNr > -1){
//    error_log(print_r($mr->dimNr,true));
    
    $dim = $query->dimensions[$mr->dimNr]->dimName;
?>
 <tr><td ><?=WSRTranslate::translateH('verwendete Dimension')?></td>
 <td><?=$mr->dimNr ?>: <?=$dim?> 
 </td></tr>
 <?php 
}
 ?>
 <tr><td class="help"	
 title="<?=WSRTranslate::translate('Dimension die für den Wert oder Filter erfordelich sind.
 Muss bei neu angelegten Elementen und bei Soderfilter eingegeben werden.')?>"
 ><?=WSRTranslate::translateH('erforderliche Dimensionen')?></td>
 <td>
 <?php 
 $di = 0;
 foreach ($query->dimensions as $nr=>$dim){
     if ($di == 3){
         echo "<br>\n";
         $di = 0;
     }
     $di ++;
 ?>
 <input type="checkbox" <?=checked(in_array($nr, $mr->reqDim)) ?>
  onchange="setMetaAttrib('setDimReq<?=$nr?>',this.checked)" >&nbsp;<?=''.$nr.':&nbsp;'.$dim->dimName ?>
 <?php }?>
 </td></tr>
 <?php
 if ($wo != 3){
 ?>
 <tr><td><?=WSRTranslate::translateH('Chart-Farbe')?>:</td><td><input type="text" name="chartColor" value="<?=$mr->chartColor ?>" size="10"  
 onchange="setMetaAttrib('chartColor',this.value)" autocomplete="off" /></td></tr>
 <tr><td><?=WSRTranslate::translateH('Chart-Farbe wenn negativ')?>:</td><td><input type="text" name="chartNegColor" value="<?=$mr->chartNegColor ?>" 
 onchange="setMetaAttrib('chartNegColor',this.value)" size="10"   autocomplete="off" /></td></tr>
 <tr><td><?=WSRTranslate::translateH('Chart-Gruppe')?>:</td><td>
 <input type="text" name="chartGroup" value="<?=blankAsNull($mr->chartGroup) ?>" size="30"   autocomplete="off"
 onchange="setMetaAttrib('chartGroup',this.value)" /></td></tr>

 <tr><td class='help' title="<?=WSRTranslate::translate('Optionale Unter- und Obergrenzen,
 damit Extremwerte die Charts für Normalfälle
 nicht unbrauchbar machen.')?>" 
 ><?=WSRTranslate::translateH('Chart-Skalierung')?>:</td><td><?=WSRTranslate::translateH('Untergrenze')?>:
 <input type="text" name="chartGroup" value="<?=blankAsNull($mr->chartMin) ?>" size="8"   autocomplete="off"
 onchange="setMetaAttrib('chartMin',this.value)" />
 <?=WSRTranslate::translateH('Obergrenze')?>:
 <input type="text" name="chartGroup" value="<?=blankAsNull($mr->chartMax) ?>" size="8"   autocomplete="off"
 onchange="setMetaAttrib('chartMax',this.value)" /></td></tr>
<?php
 }
/*
 *  <tr><td>Braucht Sonderbehandlung:</td><td>
   <select name="brauchtSonderbehandlung" >
 <option value="false" <?=checkSel($mr->brauchtSonderbehandlung,"false") ?> >nein</option>
 <option value="true" <?=checkSel($mr->brauchtSonderbehandlung,"true") ?> >ja</option>
 </select>
 </td></tr>
 * 
 */
?>
 
 
 
 </table>
 </form>
 
 <div class="center">
  <button onclick="loadMusterVar()"><?=WSRTranslate::translate('Muster laden')?></button> 
  <button onclick="saveMusterVar()"><?=WSRTranslate::translate('Als Muster speichern')?></button> 
  <button onclick="closeEditor()"><?=WSRTranslate::translate('Schließen')?></button> 
 </div><br><br><br>
 