<?php
/**
 * Projekt: WS-Reporter
 *          Neue Variable bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.10.2021
 *
 */
// http_response_code (425);
// Es fehlen noch die Join-Vars

if (false) {
    $query = new Query("TAB");
}
$wo = $_REQUEST['wo'];
$name = $_REQUEST['name'];
if(strpos($name, "?") !== FALSE){
    require_once './phpsec/createDBH.inc';    
    $query->showMuster = $wo;
    if ($wo < 4 || $wo >= 100){
        $sql = new SqlAbfrage('WSR');
        $sql->sql = 'select distinct case (substring(column_name,2,1)) when ":" then substring(column_name,3) '
            .' else column_name end as name, column_label as label, column_desc as description from queryColumnMetadata';
        $sql->addSel("table_name=", $query->muster_tabelle);
        if ( $wo >= 100) {
            $wo = 100;
            $query->showMuster = $wo;
            $sql->startAddSel("column_name like ", str_replace('?', '%', trim($name)));
            $sql->endAddSel("or column_name like ", str_replace('?', '%', '_:'.trim($name)));
            $sql->addSel("SpaltenTyp >= ", $wo);
            
        }
        else{
            $sql->addSel("column_name like ", str_replace('?', '%', trim($name)));
            $sql->addSel("SpaltenTyp =", $wo);
        }
        $sql->sql .= ' order by name';
        $stmt = $sql->execute();
        if ($stmt == false){
            $query->musterListe["FEHLER"] = array("Fehler",$stmt->errorInfo()[2] );
            die();
        }
    }elseif ($wo == 4){
        $sql = new SqlAbfrage('WSR');
        $sql->sql = 'SELECT a.table_name as name, a.attribute as label, b.attribute as description '
            .' FROM queryAttribute a left join `queryAttribute` b on b.table_name = a.table_name and b.satztyp = 5';
        $sql->addSel("a.table_name like ", str_replace('?', '%', trim($name)));
        $sql->addSel("a.satztyp =", 2);
        $sql->sql .= ' order by name';
        $stmt = $sql->execute();
        
        if ($stmt == false){
            die();
        }
    }elseif ($wo == 5){
        $sql = new SqlAbfrage('WSR');
        $sql->sql = 'SELECT a.table_name as name, a.attribute as label, b.attribute as description '
            .' FROM queryAttribute a join `queryAttribute` d on d.table_name = a.table_name and d.satztyp = 10'  
            .' and d.attribute = "'.Query::DIMENSION.'" left join `queryAttribute` b on b.table_name = a.table_name and b.satztyp = 5';
            $sql->addSel("a.table_name like ", str_replace('?', '%', trim($name)));
            $sql->addSel("a.satztyp =", 2);
            $sql->sql .= ' order by name';            
            $stmt = $sql->execute();
            
            if ($stmt == false){                
                die();
            }
    }
    $query->musterListe = array();
    while ($z = $stmt->fetchObject()) {
        $t = array();
        $t[0] = $z->label;
        $t[1] = $z->description;
        $query->musterListe[$z->name] = $t;
    }
    die();    
}else{
    if ($wo < 4){
        if (array_key_exists($name, $query->metaData)
            ){
                http_response_code (425);
                echo 'Der Name wird schon verwendet';
                die;
            }
        $metaRecord = new MetaRecord();
        $metaRecord->init($query->class_table, $name);
        $query->metaData[$name] = $metaRecord;
        
        switch ($wo){
            case 1: $query->rowVars[] = $name;
            break;
            case 2: $query->valueVars[] = $name;
            break;
            case 3: $query->filterVars[] = $name;
            break;
        }
    }else
        if ($wo == 4){
        $newAdd = new AddedQuery($name);
        $query->addQueries->put($newAdd);
    }else
        if ($wo == 5){
            $dim=$query->addNewDimension($name);
    }else
        if ($wo == 6){
            for ($i = 0; $i < count($query->defaultFilter); $i++)
                if ($query->defaultFilter[$i]->column_name == trim($name)) return;
            $query->defaultFilter[] = new DefaultFilter(trim($name));
    }else
        if ($wo == 100 && $query->qEditSubject >= 100){
            $aq = $query->addQueries->getPos($query->qEditSubject - 100);
            $jq = $aq->getQuery();
            if ($jq == null){
                http_response_code(425);
                echo "Ungültiger Aufruf:\nJoin an Position ".(qEditSubject - 100)." nicht gefunden\n";
                echo var_dump($_REQUEST);
                return;
            }
            $v = $_REQUEST['name'];
            if (array_key_exists($v, $jq->metaData)){
                http_response_code(425);
                echo "FEHLER:\nDie Variable $v gibt es schon";
                echo var_dump($_REQUEST);
                return;
            }
            $mr = new MetaRecord();
            $mr->init($jq->class_table, $v);
            $aq->calcVars[] = $v;
            $jq->metaData[$v] = $mr;
            return;
    }
}
/*        String name = request.getParameter("name").trim().replaceAll(" ", "");
        if (wo == 1 ) {
            request.setAttribute("Display", "Zeilen");
        }
        else
            if (wo == 2) {
                request.setAttribute("Display", "Werte");
            }
        else
            if (wo == 3) {
                request.setAttribute("Display", "Filter");
            }
        else {
            response.setStatus(425);
            response.setContentType("text/plain");
            response.getWriter().println("insert Var: bei wo="+wo+" nicht möglich.");
            return;
        }
        request.setAttribute("ReportQuery", rQuery);
        if (!rQuery.insertVarAt(wo, name)) {
            response.setStatus(425);
            response.setContentType("text/plain");
            response.getWriter().println(rQuery.getLastError());
            return;
        }
        if (program.equals("newMusterVar")) {
            if (!rQuery.readMuster(name, wo)) {
                response.setStatus(425);
                response.setContentType("text/plain");
                response.getWriter().println(rQuery.getLastError());
                return;
            }
        }
 */ 
    
?>