<?php
/**
 * Projekt: WS-Reporter
 *          Spezifikation einer Datenquelle aus Datei importieren
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    23.02.2023
 *
 */


function importClassDef($datei){
global $query, $queryVersion, $dwhListe;
adminRechteVerlangen();

$queryVersion = '0.1';
$query = new Query(null);
$query->rowVars = array();
$query->valueVars = array();
$query->filterVars = array();
$query->dimensions = array();
$query->metaData = array();
$query->addQueries = new Vector();
$query->repRows = new Vector();
$query->repValues = new Vector();
$query->repColumns = new Vector();
$query->repFilter = new Vector();
$query->repTables = new Vector();

$readTableDescription = false;
$newDim = null;
$defaultFilter = null;
$fertig = false;

while (($zeile = fgets($datei)) !== false && ! $fertig) {
    $zeile = trim($zeile);
    if (strpos($zeile,"<classTable>") === 0) $query->class_table = substr($zeile, strlen("<classTable>"));
    if (strpos($zeile,"<defaultTitle>") === 0) $query->defaultTitle = substr($zeile, strlen("<defaultTitle>"));
    if (strpos($zeile,"<outputTitlePrefix>") === 0) $query->outputTitlePrefix = substr($zeile, strlen("<outputTitlePrefix>"));
    if (strpos($zeile,"<reportCSS>") === 0) $query->reportCSS = substr($zeile, strlen("<reportCSS>"));
    if (strpos($zeile,"<reportHoverMode>") === 0) $query->reportHoverMode = 1* substr($zeile, strlen("<reportHoverMode>"));
    if (strpos($zeile,"<dwh>") === 0) {
        $dwh =  substr($zeile, strlen("<dwh>"));
        if (in_array($dwh, $dwhListe)) $query->dwh = $dwh;
        else error_log('Datenbank '.$dwh.' ist nicht bekannt.');
    }
    if (strpos($zeile,"<userStored>") === 0) $query->importUserCreated = substr($zeile, strlen("<userStored>"));
    if (strpos($zeile,"<timeStored>") === 0) $query->importTimeCreated = substr($zeile, strlen("<timeStored>"));
    if (strpos($zeile,"<userReleased>") === 0) $query->importUserReleased = substr($zeile, strlen("<userReleased>"));
    if (strpos($zeile,"<timeReleased>") === 0) $query->importTimeReleased = substr($zeile, strlen("<timeReleased>"));
    
    if (strpos($zeile,"<physTable>") === 0) $query->phys_table = substr($zeile, strlen("<physTable>"));
    if (strpos($zeile,"<queryVersion>0.5") === 0) $queryVersion = '0.5';
    if (strpos($zeile,"<queryVersion>0.6") === 0) $queryVersion = '0.6';
    if (strpos($zeile,"<queryVersion>0.7") === 0) $queryVersion = '0.7';
    if (strpos($zeile,"<queryType>") === 0) $query->queryType = 1*substr($zeile, strlen("<queryType>"));
    if (strpos($zeile,"<queryDimKey>") === 0) $query->dimKey = substr($zeile, strlen("<queryDimKey>"));

    if (strpos($zeile,"<queryHistType>") === 0) $query->histType = 1 * substr($zeile, strlen("<queryHistType>"));
    if (strpos($zeile,"<queryHistOption>") === 0) $query->historyOption = 1 * substr($zeile, strlen("<queryHistOption>"));
    if (strpos($zeile,"<queryHistAb>") === 0) $query->histAb = substr($zeile, strlen("<queryHistAb>"));
    if (strpos($zeile,"<queryHistBis>") === 0) $query->histBis = substr($zeile, strlen("<queryHistBis>"));
    if (strpos($zeile,"<queryHistStichtag>") === 0) $query->histStichtag = substr($zeile, strlen("<queryHistStichtag>"));
    if (strpos($zeile,"<queryHistDate>") === 0) $query->historyDate = substr($zeile, strlen("<queryHistDate>"));
    if (strpos($zeile,"<hatWerteAuswahl>") === 0) $query->hatWerteAuswahl = true;
    
    if (strpos($zeile,"<tableDescription>") === 0) {
        $query->table_description = "";
        while (($zeile = fgets($datei)) !== false && (strpos($zeile, "<endTableDescription>") === false)) {
            $query->table_description.=$zeile;
        }
        $query->table_description = trim($query->table_description);
    }
    
    if (strpos($zeile,"<tableDescriptionTranslated>") === 0) {
        $lang = substr($zeile,strlen("<tableDescriptionTranslated>"),2);
        $query->queryImported = true;
        if ($query->description_imported == null) $query->description_imported = array();
        $query->description_imported[$lang] = "";
        while (($zeile = fgets($datei)) !== false && (strpos($zeile, "<endTableDescriptionTranslated>") === false)) {
            $query->description_imported[$lang].=$zeile;
        }
//        $query->description_imported[$lang] = trim($query->description_imported[$lang]);
//        error_log('Importiere Description '.$lang);
//        error_log('>'.$query->description_imported[$lang].'<');
    }

    if (strpos($zeile,"<tableHints>") === 0) {
        $query->table_hints = "";
        while (($zeile = fgets($datei)) !== false && (strpos($zeile, "<endTableHints>") === false)) {
            $query->table_hints.=$zeile;
        }
        $query->table_hints = trim($query->table_hints);
    }
    
    if (strpos($zeile,"<tableHintsTranslated>") === 0) {
        $lang = substr($zeile,strlen("<tableHintsTranslated>"),2);
        $query->queryImported = true;
        if ($query->hints_imported == null) $query->hints_imported = array();
        $query->hints_imported[$lang] = "";
        while (($zeile = fgets($datei)) !== false && (strpos($zeile, "<endTableHintsTranslated>") === false)) {
            $query->hints_imported[$lang].=$zeile;
        }
        //        $query->hints_imported[$lang] = trim($query->hints_imported[$lang]);
        //        error_log('Importiere Description '.$lang);
        //        error_log('>'.$query->hintsa_imported[$lang].'<');
    }
    
    
    if (strpos($zeile,"<qLanguage>") === 0) $query->qLanguage = substr($zeile, strlen("<qLanguage>"));
    if (strpos($zeile,"<qTranslations>") === 0) {
        $query->qTranslations  = explode(' ', substr($zeile, strlen("<qTranslations>")));
    }
    
    if (strpos($zeile,"<MetaRecord>") === 0) {
        $metaRecord = new MetaRecord();
        $metaRecord->setTable($query->class_table);
        $metaRecord->import($datei);
        $query->metaData[$metaRecord->getName()] = $metaRecord;
//        echo '<pre>'.var_dump($metaRecord).'</pre>';
    }
//    if (strpos($zeile,"<rowVars>") === 0) echo '<pre>'.var_dump($query->metaData).'</pre>';
    if (strpos($zeile,"<rowVar>") === 0) $query->rowVars[] = substr($zeile, strlen("<rowVar>"));
    if (strpos($zeile,"<valueVar>") === 0) $query->valueVars[] = substr($zeile, strlen("<valueVar>"));
    if (strpos($zeile,"<filterVar>") === 0) $query->filterVars[] = substr($zeile, strlen("<filterVar>"));
    
    if (strpos($zeile,"<defaultFilter>") === 0) $defaultFilter = new DefaultFilter(trim(substr($zeile, strlen("<defaultFilter>"))));
    if (strpos($zeile,"<defaultFilterVon>") === 0) {
        if ($defaultFilter == null) error_log("Fehler bei DefaultFilter-Von");
        else 
        $defaultFilter->fs_von = trim(substr($zeile, strlen("<defaultFilterVon>")));
    }
    if (strpos($zeile,"<defaultFilterBis>") === 0) {
        if ($defaultFilter == null) error_log("Fehler bei DefaultFilter-Bis");
        else
            $defaultFilter->fs_bis = trim(substr($zeile, strlen("<defaultFilterBis>")));
    }
    
    if ($zeile == "<endDefaultFilter>"  && $defaultFilter != null) {
        $query->defaultFilter[] = $defaultFilter;
        $defaultFilter = null;
    }
    
    if (strpos($zeile,"<addQuery>") === 0) {
        $adq = new AddedQuery(substr($zeile, strlen("<addQuery>")));
        $query->addQueries->put($adq);
        while (($zeile = fgets($datei)) !== false && (strpos($zeile, "</addQuery>") === false)) {
            $zeile = trim($zeile);
            if (strpos($zeile,"<calculatedVar>") === 0) $adq->calcVars[] = substr($zeile, strlen("<calculatedVar>"));
            if (strpos($zeile,"<MetaRecord>") === 0) {
                $metaRecord = new MetaRecord();
                $metaRecord->setTable($query->class_table);
                $metaRecord->import($datei);
                $adq->getQuery()->metaData[$metaRecord->getName()] = $metaRecord;
            }
        }        
    }
    if (strpos($zeile,"<dimension>") === 0){
        $newDim = new Dimension(null);
        $newDim->dimNr = 1*substr($zeile, strlen("<dimension>"));
    }
    if (strpos($zeile,"</dimension>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $query->dimensions[$newDim->dimNr] = $newDim;
        $newDim = null;
    }

    if (strpos($zeile,"<dimensionName>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->dimName = substr($zeile, strlen("<dimensionName>"));
    }
    if (strpos($zeile,"<dimensionPhysTable>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->phys_table = substr($zeile, strlen("<dimensionPhysTable>"));
    }
    if (strpos($zeile,"<dimensionKey>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->dimKey = substr($zeile, strlen("<dimensionKey>"));
    }
    if (strpos($zeile,"<dimensionType>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->dimType = 1*substr($zeile, strlen("<dimensionType>"));
    }
    if (strpos($zeile,"<dimensionSelectVar>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->dimSelectVar = substr($zeile, strlen("<dimensionSelectVar>"));
    }
    if (strpos($zeile,"<dimensionBaseKey>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->baseKey = substr($zeile, strlen("<dimensionBaseKey>"));
    }
    if (strpos($zeile,"<dimensionBaseDimNr>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->baseDimNr = 1*substr($zeile, strlen("<dimensionBaseDimNr>"));
    }
    
    if (strpos($zeile,"<dimensionHistType>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->histType = 1*substr($zeile, strlen("<dimensionHistType>"));
    }    
    if (strpos($zeile,"<dimensionHistOption>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->historyOption = 1*substr($zeile, strlen("<dimensionHistOption>"));
    }    
    if (strpos($zeile,"<dimensionHistAb>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->histAbSelect = substr($zeile, strlen("<dimensionHistAb>"));
    }    
    if (strpos($zeile,"<dimensionHistBis>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->histBisSelect = substr($zeile, strlen("<dimensionHistBis>"));
    }    
    if (strpos($zeile,"<dimensionHistStichtag>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->histStichtagSelect = substr($zeile, strlen("<dimensionHistStichtag>"));
    }    
    if (strpos($zeile,"<dimensionHistDate>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->historyDate = substr($zeile, strlen("<dimensionHistDate>"));
    }
    if (strpos($zeile,"<dimensionDimIsFilter>") === 0){
        if ($newDim == null){
            http_response_code(425);
            echo "FEHLER im Import bei Dimensionen Nr. 2\n$zeile ohne offene Dimension.";
            die();
        }
        $newDim->dimIsFilter = true;
    }
    
    
    
    /*
    if (strpos($zeile,"") === 0) $query-> = substr($zeile, strlen(""));
    if (strpos($zeile,"") === 0) $query-> = substr($zeile, strlen(""));
    if (strpos($zeile,"") === 0) $query-> = substr($zeile, strlen(""));
    if (strpos($zeile,"") === 0) $query-> = substr($zeile, strlen(""));
    if (strpos($zeile,"") === 0) $query-> = substr($zeile, strlen(""));
  */ 
    if (strpos($zeile,"<WS-Report Translations Version 1.0>") === 0) $fertig = true;
        
}
setdbDWH($query->dwh);
}