<?php
/**
* Die Datei index.inc wird von index.php gelesen um sich in
* die jeweilige WEB-Umgebung einzupassen.
* Dabei werden die Abschnitte vor und hinter der Anmeldung
* über die Variable $part ausgewählt.
* Vor dem Index steht 
*   $part == "Anmeldung"
* oder
*   $part == "Angemeldet"  
* Danach kommt die Ausgabe von $index.php. 
* 
* Hinter dem Index steht $part == "Ende"
* 
* Wenn es die index.inc nicht gibt, wird diese
* index-fallback.inc verwendet.
*/
global $part;
if (isset($part) && 
    ($part == "Anmeldung"
        || $part == "Angemeldet")){
?>    
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<?php     
 if (isset($part) && 
     ($part == "Anmeldung" || $part == "Ende")){
?>
<title>WS-Reporter: Anmeldung</title>
<?php     
}else if (isset($part) && $part == "Angemeldet"){
?>
<title>WS-Reporter: Startseite</title>
<?php     
}
?>
<meta name="GENERATOR" content="WS-PHP: index.php">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" href="./jscss/standard2.css">
</head>
<body>
<?php     
 if (isset($part) && $part == "Anmeldung"){
?>
<h1>Anmeldung für den WS-Reporter</h1>    
<p>Der WS-Reporter erfordert zwingend eine Anmeldung.</p>
<div class="inlineBox centerBox">
<?php     
}else if (isset($part) && $part == "Angemeldet"){
?>
<h1>WS-Reporter</h1>
<div class="inlineBox centerBox">
<?php     
}
}else if (isset($part) && $part == "Ende"){
?>
</div>
<br>
<footer class="leiste">
<div class="Fleft">WS Reporter</div>
<div class="Fright right">&copy; WS Unternehmensberatung</div>
</footer>
</body>
</html>    
<?php     
}
?>