<?php
/**
 * Projekt: WS-Reporter
 *          Spezifikation der Datenquelle ausgeben
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    24.02.2023 MS
 *
 */
include 'includes/defender.inc';
// Ausgabe der Report-Definition
global $query, $meldungen;
require_once './includes/funktionen.inc';
require_once './includes/classes.inc';

if (false){
    $query = new Query("tab");
    $rq = new Query("tab");
    $jquery = new Query("tab");
    $aq = new AddedQuery("tab");
    $mr = new MetaRecord();
    $mr2 = new MetaRecord();
    $mrf = new MetaRecord();
    $jt = new JoinedTable(null);
    $fSpec = new RepFilter("fi");
}

global $query, $wsReportVersion;
$meldungen = "";
$border ="";
$query = null;
if (session_status() == PHP_SESSION_NONE)  session_start();

anmeldungPruefen();

if (array_key_exists('WSReportQuery', $_SESSION)){
    $query = $_SESSION['WSReportQuery'];
}
session_write_close();


if (array_key_exists('table', $_REQUEST)){
    if ($query == null || $query->class_table != $_REQUEST['table']){
        require_once './includes/loadClassDef.inc';
        $query = new Query($_REQUEST['table']);
        loadClassDef($query);
    }
}
if ($query == null){
    echo WSRTranslate::translateH("FEHLER:<br>Die Defintion der Datenquelle")." "
        .$_REQUEST['table']." ".WSRTranslate::translateH("konnte nicht geladen werden.");
    echo '<br><pre>';var_dump($query);echo '</pre>';
    die();
}
$meldungen ='';
leseRechteVerlangen();


function displayFilterDef($mr){
    if ($mr->filterType == MetaRecord::NONE) return;
?>
    <tr><th class="left" >Filter-Typ</th>
    <td><?=MetaRecord::getKlartextFilter($mr->filterType)?></td></tr>
<?php 
    if ($mr->filterType == MetaRecord::SELECT
        || $mr->filterType == MetaRecord::TEXTMITLABEL
        || $mr->filterType == MetaRecord::VON_BIS_SELECT){
    		if (isValid($mr->selectFilterTable)){
?>
    <tr><th class="left" ><?=WSRTranslate::translateH('Werte-Tabelle')?></th>
    <td><?=$mr->selectFilterTable?></td></tr>
    <tr><th class="left" ><?=WSRTranslate::translateH('Sortierung der Auswahl')?></th>
    <td><?=$mr->getMyKlartextFilterSort()?></td></tr>
<?php 
    	if (isValid($mr->selectFilterVar)){
?>
    <tr><th class="left" ><?=WSRTranslate::translateH('Filter-Spalte')?></th>
    <td><?=$mr->selectFilterVar?></td></tr>
<?php 
        }
    	if (isValid($mr->selectFilterTable2)){
?>
    <tr><th class="left" ><?=WSRTranslate::translateH('Zweite Werte-Tabelle zum Eingrenzen')?></th>
    <td><?=$mr->selectFilterTable2?></td></tr>
<?php 
    }
	   if (isValid($mr->selectFilterVar2)){
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Filter-Spalte in zweiter Tabelle')?></th>
<td><?=$mr->selectFilterVar2?></td></tr>
<?php 
        }
	}else{ // Select ohne Filter-Tabelle
		?>
		<tr><th class="left" colspan = "2"><?=WSRTranslate::translateH('Werte-Auswahl')?></th></tr>
			<tr><th ><?=WSRTranslate::translateH('Wert')?></th>
			<th><?=WSRTranslate::translateH('Anzeige')?></th></tr>
		<?php 
		$selOpts = $mr->getSelectOptions();
		if ($selOpts != null) {
		    $jmax = count($selOpts);
    		if ($jmax > 20) $jmax = 10;
    		for ($j = 0; $j < $jmax; $j++){
    			?>
    			<tr><td ><?=$mr->getSelectOptions()[$j][0]?> </td>
    			<td><?=$mr->getSelectOptions()[$j][1]?></td></tr>
    			<?php 			
    		}
    		
    	    if ($jmax < count($selOpts)){
    			?>
    			<tr><td >... </td>
    			<td>&nbsp;</td></tr>
    			<?php
    	    }
		}
	} // if SELECT
?>
<?php 
    } else if ($mr->filterType == MetaRecord::SONDERFILTERSEL){
?>		
		<tr><th class="left" colspan = "2">&nbsp;</th></tr>
		<tr><th ><?=WSRTranslate::translateH('Anzeige')?></th>
		<th><?=WSRTranslate::translateH('Filter-Code')?></th></tr>
	<?php 
	$jmax = count($mr->getSelectOptions());
	if ($jmax > 20) $jmax = 10;
	for ($j = 0; $j < $jmax; $j++){
	    ?>
			<tr><td ><?=$mr->getSelectOptions()[$j][0]?> </td>
			<td><?=$mr->getSelectOptions()[$j][1]?></td></tr>
			<?php 			
		}
		
	    if ($jmax < count($mr->getSelectOptions())){
			?>
			<tr><td >... </td>
			<td>&nbsp;</td></tr>
			<?php 			
		}
      } // if SONDERFILTERSEL
          else if ($mr->filterType == MetaRecord::SONDERFILTER){
    ?>
		<tr><th class="left"><?=WSRTranslate::translateH('Code')?></th>
		
		<td><?=quoteForHTML($mr->selectVar)?></td></tr>
<?php 			
      } // if SONDERFILTER
      else if ($mr->filterType == MetaRecord::WINDOWFILTER){
          ?>
		<tr><th class="left"><?=WSRTranslate::translateH('Code')?></th>
		
		<td><?=quoteForHTML($mr->selectVar)?></td></tr>
<?php 			
      } // if SONDERFILTER
}
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title><?=$query->outputTitlePrefix.': '.WSRTranslate::translate('Dokumentation der Datenquelle')?></title>
<meta name="GENERATOR" content="WS-PHP: reportClassDef.php">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="<?=$query->reportCSS ?>" >
</head> 
<?php 
if ($_SERVER["HTTP_HOST"] == "localhost:8898") echo '<body class="entwicklung">';
else echo '<body>';
?>
<h1><?=WSRTranslate::translateH('Dokumentation zu').' '.quoteForHTML($query->outputTitlePrefix )?></h1>


<div class="kommentar">
<h3><?=WSRTranslate::translateH('Globale Eigenschaften')?></h3>


<table  <?=$border ?> class="aLeft">
<?php
if ($query->queryType > Query::DATEN){
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Typ der Datenquelle')?></th>
<td><b><?=$query->getTypeText($query->queryType)?></b></td></tr>

<?php 
}
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Standard-Fenster-Titel')?></th><td><?=$query->outputTitlePrefix?></td></tr>
<tr><th class="left" ><?=WSRTranslate::translateH('Standard-Report-Name')?></th><td><?=$query->defaultTitle?></td></tr>
<tr><th class="left" ><?=WSRTranslate::translateH('interner Name')?></th><td><?=$query->class_table?></td></tr>
<?php 
// Administrative Informationen
if ($query->queryImported){
    if (isValid($query->importUserCreated)){
        ?>
<tr><th class="left"><?=WSRTranslate::translateH('Erstellt von') ?></th>
<td><?=$query->importUserCreated?>
(<?=WSRFormats::formatDateTime(DateTime::createFromFormat('Y-m-d H:i:s',$query->importTimeCreated)) ?>)</td></tr>    
<?php         
    }
    if (isValid($query->importUserReleased)){
        ?>
<tr><th class="left"><?=WSRTranslate::translateH('Freigegeben von') ?></th>
<td><?=$query->importUserReleased?> 
(<?=WSRFormats::formatDateTime(DateTime::createFromFormat('Y-m-d H:i:s',$query->importTimeReleased)) ?>)</td></tr>    
<?php         
    }
}else {
    $logSql = new SqlAbfrage('WSR');
    $logSql->sql = 'select * from wsrAdminQuery';
    $logSql->addSel('table_name = ', $query->class_table);
    $stmt = $logSql->execute();
    $z = $stmt->fetchObject();
    if (isValid($z->userCreated)){
?>    
<tr><th class="left"><?=WSRTranslate::translateH('Erstellt von') ?></th>
<td><?=$z->userCreated ?> (<?=WSRFormats::formatDateTime(DateTime::createFromFormat('Y-m-d H:i:s',$z->timeCreated)) ?>)</td></tr>    
<?php         
    }
    if (isValid($z->userStored)){
        ?>
<tr><th class="left"><?=WSRTranslate::translateH('Zuletzt gespeichert von') ?></th>
<td><?=$z->userStored ?> (<?=WSRFormats::formatDateTime(DateTime::createFromFormat('Y-m-d H:i:s',$z->timeStored)) ?>)</td></tr>    
<?php         
    }
    if (isValid($z->userReleased)){
        ?>
<tr><th class="left"><?=WSRTranslate::translateH('Freigegeben von') ?></th>
<td><?=$z->userReleased ?> (<?=WSRFormats::formatDateTime(DateTime::createFromFormat('Y-m-d H:i:s',$z->timeReleased)) ?>)</td></tr>    
<?php         
    }
    if (isValid($z->userResponsible)){
        ?>
<tr><th class="left"><?=WSRTranslate::translateH('Verantwortlich') ?></th>
<td><?=$z->userResponsible ?></td></tr>    
<?php         
    }
    
}
// Ende Administrative Informationen
?>
<tr><th class="left"><?=WSRTranslate::translateH('Sprache(n)') ?></th>
<td><?php echo $query->qLanguage.' '; foreach ($query->qTranslations as $t) echo $t.' ' ?></td></tr>    

<tr><th class="left" ><?=WSRTranslate::translateH('projektspezifisches CSS-Sheet')?></th><td><?=$query->reportCSS?></td></tr>
<tr><th class="left" ><?=WSRTranslate::translateH('DWH-DB')?></th><td><?=$query->dwh?></td></tr>
<tr><th class="left" ><?=WSRTranslate::translateH('physische Tabelle')?></th><td><?=$query->phys_table?></td></tr>
<?php
if ($query->queryType == Query::DIMENSION){
    ?>
    <tr><th class="left" ><?=WSRTranslate::translateH('Key-Zeile zum Verkn.')?></th><td><?=$query->dimKey?></td></tr>
<?php 
}
?>
<?php
if ($query->histType > 0){
    ?>
    <tr><th class="left" ><?=WSRTranslate::translateH('Historisierung')?></th><td><?=Query::getHistText($query->histType)?></td></tr>
<?php 
if ($query->histType == Query::VONBIS){
    ?>
    <tr><th class="left" ><?=WSRTranslate::translateH('Intervall aus')?></th><td>
    <?php if (isValid($query->histAb)) echo $query->histAb; else echo WSRTranslate::translateH('FEHLT')?> 
    <b><?=WSRTranslate::translateH('bis')?></b> 
    <?php if (isValid($query->histBis)) echo $query->histBis; else echo WSRTranslate::translateH('FEHLT')?> 
    </td></tr>
<?php 
}else{
    ?>
    <tr><th class="left" ><?=WSRTranslate::translateH('Stichtag aus')?></th><td>
    <?php if (isValid($query->histStichtag)) echo $query->histStichtag; else echo WSRTranslate::translateH('FEHLT')?> 
    </td></tr>
<?php 
}
if ($query->historyOption > 0){
    ?>
    <tr><th class="left" ><?=WSRTranslate::translateH('Ermittlung Stichtag')?></th><td>
    <?= HistoryOptions::getKlartext($query->historyOption)?>
    <?php if (isValid($query->historyDate))
        echo WSRFormats::formatDate(DateTime::createFromFormat('Y-m-d',$query->historyDate)); ?> 
    </td></tr>
<?php 
}
}
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Beschreibung')?></th><td><?=quoteForHTML($query->table_description)?></td></tr>
<?php
if (isValid($query->table_hints)){
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Technische Hinweise')?></th><td><?=quoteForHTML($query->table_hints)?></td></tr>
<?php
}
// Lookup-Tabellen für Auswahllisten
$physTables = array();
foreach ($query->metaData as $mr){
    if (false) $mr = new MetaRecord();
    if ($mr->filterType > MetaRecord::NONE){
        if (isValid($mr->selectFilterTable)){
            if (array_key_exists($mr->selectFilterTable, $physTables))
                $physTables[$mr->selectFilterTable] ++;
            else
                $physTables[$mr->selectFilterTable] = 1;
        }
        if (isValid($mr->selectFilterTable2)){
            if (array_key_exists($mr->selectFilterTable2, $physTables))
                $physTables[$mr->selectFilterTable2] ++;
                else
                    $physTables[$mr->selectFilterTable2] = 1;
        }
    }
}
if (count($physTables) > 0){
    $c = 0;
    foreach ($physTables as $t=>$count){
        if ($c == 0){
            ?>
<tr><th class="left" rowspan="<?=count($physTables) ?>"><?=WSRTranslate::translateH('physische Lookup-Tabellen')?></th>
<td><?php echo $t; if ($count > 1) echo "({$count})";?></td></tr>
<?php 
        $c++;
        }else{
            ?>
<tr><td><?php echo $t; if ($count > 1) echo "({$count})";?></td></tr>
<?php 
        }
    }
}

// Physische Tabellen aus verknüpften Datenquellen
$physTables = array();
for ($i=0; $i < $query->addQueries->size();$i++){
    $aq = $query->addQueries->getPos($i);
    if (false) $aq = new AddedQuery($table);
    if ($aq->class_table != $query->class_table){
        $physTable = $aq->getQuery()->phys_table;
        if ($physTable != $query->phys_table)
            if (! array_key_exists($physTable, $physTables))
                    $physTables[$physTable] = $aq->class_table; 
    }
}
if (count($physTables) > 0){
    $c = 0;
    foreach ($physTables as $t=>$cl){
        if ($c == 0){
            ?>
<tr><th class="left" rowspan="<?=count($physTables) ?>"><?=WSRTranslate::translateH('verknüpfbare phys. Tabellen')?></th>
<td class="nowrap"><?=$t?> (<?=$cl?>)</td></tr>
<?php 
        $c++;
        }else{
            ?>
<tr><td class="nowrap"><?=$t?> (<?=$cl?>)</td></tr>
<?php 
        }
    }
}


if (count($physTables) > 0){
    $c = 0;
    foreach ($physTables as $t=>$count){
        if ($c == 0){
            ?>
<tr><th class="left" rowspan="<?=count($physTables) ?>"><?=WSRTranslate::translateH('physische Lookup-Tabellen')?></th>
<td><?php echo $t; if ($count > 1) echo "({$count})";?></td></tr>
<?php 
        $c++;
        }else{
            ?>
<tr><td><?php echo $t; if ($count > 1) echo "({$count})";?></td></tr>
<?php 
        }
    }
}

// Dimensionen
if (count($query->dimensions) > 0){
    $c = 0;
    foreach ($query->dimensions as $nr=>$dim){
        if (false ) $dim = new Dimension('N');
        if ($c == 0){
            ?>
<tr><th class="left" rowspan="<?=count($query->dimensions) ?>"><?=WSRTranslate::translateH('Dimensionen')?><br>
(<?=WSRTranslate::translateH('phys. Tabellenname/Verknüpfung')?>)</th>
<td class="nowrap"><?=$nr?>: <?=$dim->dimName?> (<?=$dim->phys_table.'/'.$dim->baseKey?>)</td></tr>
<?php 
        $c++;
        }else{
            ?>
<tr><td class="nowrap"><?=$nr?>: <?=$dim->dimName?> (<?=$dim->phys_table.'/'.$dim->baseKey?>)
<?php if ($dim->histType > 0) echo ' - '.Query::getHistText($dim->histType) ?>
</td></tr>

<?php 
        }
    }
}
?>
</table>
<br>
<div class="small">
<?=WSRTranslate::translateH('Auswahllisten')?>:<br>
<?=WSRTranslate::translateH('#name ist eine Datenquelle vom Typ Auswahlliste')?><br>
# <?=WSRTranslate::translateH('Die Dimension oder die Basis-Quelle wird als Auswahlliste verwendet.')?>
</div>

<?php
if ($query->queryType > Query::DATEN 
    && $query->queryType < Query::DIMENSION){
?>
<p>
<h3><?=WSRTranslate::translateH('Eingabe-Felder')?></h3>
<table id="Tabelle0" <?=$border ?> class="aLeft">
<?php 
  for ($i = 0; $i < count($query->valueVars); $i++){
	  $name = $query->valueVars[$i];
	  $mr = $query->getReportMetaRecord($name);
	  if ($mr->enterValue){
?>	  
<tr><th class="left" ><a href="#<?=$name?>"><?=$name?></a></th><td><?=quoteForHTML($mr->label)?></td>
<td><?=makeDescription($mr)?></td></tr>
<?php 
	  }
  } 
?>
</table>

<?php 
}
?>
<p>
<h3><?=WSRTranslate::translateH('Übersicht Zeilen')?></h3>
<table id="Tabelle1" <?=$border ?> class="aLeft">
<?php
    $hasHidden = false;
  for ($i = 0; $i < count($query->rowVars); $i++){
	  $name = $query->rowVars[$i];
	  $mr = $query->getReportMetaRecord($name);
	  if (false) $mr = new MetaRecord();
	  if ($mr->hidden) $hasHidden = true;
	  else{
?>	  
<tr><th class="left" ><a href="#<?=$name?>"><?=$name?></a></th><td><?=quoteForHTML($mr->label)?></td>
<td><?=makeDescription($mr)?></td>
<td>
<?php
if ($mr->dimNr < 0) echo '&nbsp;';
else echo $mr->dimNr.':&nbsp;'.$query->dimensions[$mr->dimNr]->dimName;
?>
</td>
</tr>
<?php  }
  } ?>
<?php
if ($hasHidden){
    ?>
<tr><th class="left" colspan="4">verborgen:</th></tr>    
<?php
    for ($i = 0; $i < count($query->rowVars); $i++){
	  $name = $query->rowVars[$i];
	  $mr = $query->getReportMetaRecord($name);
	  if ($mr->hidden){
?>	  
<tr><td class="left" ><a href="#<?=$name?>"><?=$name?></a></td><td><?=quoteForHTML($mr->label)?></td>
<td><?=makeDescription($mr)?></td>
<td>
<?php
if ($mr->dimNr < 0) echo '&nbsp;';
else echo $mr->dimNr.':&nbsp;'.$query->dimensions[$mr->dimNr]->dimName;
?>
</td>
</tr>
<?php  }
    }
} // if $hasHidden 
?>

</table>
<p>
<?php 
if ($query->queryType < Query::DIMENSION){
    
?>
<h3><?=WSRTranslate::translateH('Übersicht Werte')?></h3>
<table id="Tabelle2" <?=$border ?>  class="aLeft">
<?php
  $hasHidden = false;
  for ($i = 0; $i < count($query->valueVars); $i++){
	  $name = $query->valueVars[$i];
	  $mr = $query->getReportMetaRecord($name);
	  if ($mr->hidden) $hasHidden = true;
	  else {
?>	  
<tr><th class="left" ><a href="#<?=$name?>"><?=$name?></a></th><td><?=quoteForHTML($mr->label)?></td>
<td><?=makeDescription($mr)?></td></tr>
<?php 
	  }
   } 
   
   if ($hasHidden){
       ?>
<tr><th class="left" colspan="3">verborgen:</th></tr>    
<?php
       for ($i = 0; $i < count($query->valueVars); $i++){
        $name = $query->valueVars[$i];
        $mr = $query->getReportMetaRecord($name);
        if ($mr->hidden){
            ?>
<tr><td class="left" ><a href="#<?=$name?>"><?=$name?></a></td><td><?=quoteForHTML($mr->label)?></td>
<td><?=makeDescription($mr)?></td></tr>
<?php 
	  }
     }
   } // if hasHidden
    ?>
</table>
<p>
<?php
if ($query->hatWerteAuswahl){
    $mr = $query->getReportMetaRecord('WSR_WERTELISTE');
    $options = $mr->getSelectOptions();
    
?>
<h3><?=WSRTranslate::translateH('Werte-Auswahl')?></h3>
<p><?=WSRTranslate::translateH('Die folgenden Werte können im Report durch den jeweils anderen Wert ersetzt werden')?></p>
<table id="Tabelle2a" <?=$border ?>  class="aLeft">
<thead>
<tr><th><?=WSRTranslate::translateH('interner Namen (Namens-Teil)')?></th>
<th><?=WSRTranslate::translateH('Anzeige für Benutzer')?></th></tr>
</thead>
<?php 
foreach ($options as $opt){
?>
<tr><th class='left'><?=$opt[0]?></th><td><?=$opt[1]?></td></tr>
<?php
} // foreach
?>
</table>
<?php
} // Werte-Auswahl
} // if $query-type < DIMENSION
?>
<h3><?=WSRTranslate::translateH('Übersicht Filter')?></h3>
<table id="Tabelle3" <?=$border ?>  class="aLeft">
<?php 
$hasHidden = false;
    for ($i = 0; $i < count($query->rowVars); $i++){
	  $name = $query->rowVars[$i];
	  $mr = $query->getReportMetaRecord($name);
	  if ($mr->hidden) $hasHidden = true;
	  else
	      
	  if ($mr->filterType > MetaRecord::NONE){
	      $e = '';
	      if ($mr->filterRequired) $e = '!'.$mr->filterRequiredGroup.'&nbsp;';
?>	  
<tr><th class="left" ><a href="#<?=$name?>"><?=$e.$name?></a></th><td><?=quoteForHTML($mr->label)?></td>
<td><?=MetaRecord::getKlartextFilter($mr->filterType)?></td>
<td><?=makeDescription($mr)?></td>
<td>
<?php
if ($mr->dimNr < 0) echo '&nbsp;';
else echo $mr->dimNr.':&nbsp;'.$query->dimensions[$mr->dimNr]->dimName;
?>
</td>
</tr>
<?php  }
  } 
for ($i = 0; $i < count($query->valueVars); $i++){
	  $name = $query->valueVars[$i];
	  $mr = $query->getReportMetaRecord($name);
	  if ($mr->filterType == MetaRecord::SONDERFILTER
	      || $mr->filterType == MetaRecord::WINDOWFILTER
	      || $mr->filterType == MetaRecord::SONDERFILTERSEL
			  ){
			      $e = '';
			      if ($mr->filterRequired) $e = '!'.$mr->filterRequiredGroup.'&nbsp;';
?>	  
<tr><th class="left" ><a href="#<?=$name?>"><?=$e.$name?></a></th><td><?=quoteForHTML($mr->label)?></td>
<td><?=MetaRecord::getKlartextFilter($mr->filterType)?></td>
<td><?=makeDescription($mr)?></td><td>&nbsp;</td></tr>
<?php  	}
} 
  for ($i = 0; $i < count($query->filterVars); $i++){
	  $name = $query->filterVars[$i];
	  $mr = $query->getReportMetaRecord($name);
	  if ($mr->hidden) $hasHidden = true;
	  else {
	      
	  $e = '';
	  if ($mr->filterRequired) $e = '!'.$mr->filterRequiredGroup.'&nbsp;';
	  if ($mr->filterType == MetaRecord::WINDOWFILTER){
	      ?>
<tr><th class="left"  title='<?=WSRTranslate::translate('Anzeige-Filter nur für Ausgabe')?>'
>*<a href="#<?=$name?>"><?=$e.$name?></a></th><td><?=quoteForHTML($mr->label)?></td>
<?php 
	  }else{
	      ?>
<tr><th class="left" ><a href="#<?=$name?>"><?=$e.$name?></a></th><td><?=quoteForHTML($mr->label)?></td>
<?php 
	  }
?>	  
<td><?=MetaRecord::getKlartextFilter($mr->filterType)?></td>
<td><?=makeDescription($mr)?></td>
<td>
<?php
if ($mr->dimNr < 0) echo '&nbsp;';
else echo $mr->dimNr.':&nbsp;'.$query->dimensions[$mr->dimNr]->dimName;
?>
</td></tr>
<?php 
	  }
  } ?>
<?php 
  for ($i = 0; $i < count($query->valueVars); $i++){
	  $name = $query->valueVars[$i];
	  $mr = $query->getReportMetaRecord($name);
	  if ($mr->filterType > MetaRecord::NONE
	      && $mr->filterType != MetaRecord::SONDERFILTER
	      && $mr->filterType != MetaRecord::SONDERFILTERSEL
			  ){
	      if ($mr->hidden) $hasHidden = true;
	      else {
			          ?>	  
<tr><th class="left" title="<?=WSRTranslate::translate('Werte-Filter nur für Ausgabe')?>" >*<a 
		href="#<?=$name?>"><?=$name?></a></th><td><?=quoteForHTML($mr->label)?></td>
<td><?=MetaRecord::getKlartextFilter($mr->filterType)?></td>
<td><?=makeDescription($mr)?></td></tr>
<?php  
	      }
	  }
  }
  
  if ($hasHidden){
      ?>
<tr><th class="left" colspan="5">verborgen:</th></tr>    
<?php
      for ($i = 0; $i < count($query->rowVars); $i++){
          $name = $query->rowVars[$i];
          $mr = $query->getReportMetaRecord($name);
          if ($mr->hidden) 
              if ($mr->filterType > MetaRecord::NONE){
                  $e = '';
                  if ($mr->filterRequired) $e = '!'.$mr->filterRequiredGroup.'&nbsp;';
                  ?>
<tr><td class="left" ><a href="#<?=$name?>"><?=$e.$name?></a></td><td><?=quoteForHTML($mr->label)?></td>
<td><?=MetaRecord::getKlartextFilter($mr->filterType)?></td>
<td><?=makeDescription($mr)?></td>
<td>
<?php
if ($mr->dimNr < 0) echo '&nbsp;';
else echo $mr->dimNr.':&nbsp;'.$query->dimensions[$mr->dimNr]->dimName;
?>
</td>
</tr>
<?php  }
  } 
for ($i = 0; $i < count($query->valueVars); $i++){
	  $name = $query->valueVars[$i];
	  $mr = $query->getReportMetaRecord($name);
	  if ($mr->filterType == MetaRecord::SONDERFILTER
	      || $mr->filterType == MetaRecord::SONDERFILTERSEL
	      ){
			      $e = '';
			      if ($mr->filterRequired) $e = '!'.$mr->filterRequiredGroup.'&nbsp;';
?>	  
<tr><td class="left" ><a href="#<?=$name?>"><?=$e.$name?></a></td><td><?=quoteForHTML($mr->label)?></td>
<td><?=MetaRecord::getKlartextFilter($mr->filterType)?></td>
<td><?=makeDescription($mr)?></td><td>&nbsp;</td></tr>
<?php  	}
} 
  for ($i = 0; $i < count($query->filterVars); $i++){
	  $name = $query->filterVars[$i];
	  $mr = $query->getReportMetaRecord($name);
	  if ($mr->hidden) {
	      
	  $e = '';
	  if ($mr->filterRequired) $e = '!'.$mr->filterRequiredGroup.'&nbsp;';
?>	  
<tr><th class="left" ><a href="#<?=$name?>"><?=$e.$name?></a></th><td><?=quoteForHTML($mr->label)?></td>
<td><?=MetaRecord::getKlartextFilter($mr->filterType)?></td>
<td><?=makeDescription($mr)?></td>
<td>
<?php
if ($mr->dimNr < 0) echo '&nbsp;';
else echo $mr->dimNr.':&nbsp;'.$query->dimensions[$mr->dimNr]->dimName;
?>
</td></tr>
<?php 
	  }
  } ?>
<?php 
  for ($i = 0; $i < count($query->valueVars); $i++){
	  $name = $query->valueVars[$i];
	  $mr = $query->getReportMetaRecord($name);
	  if ($mr->filterType > MetaRecord::NONE
	      && $mr->filterType != MetaRecord::SONDERFILTER
	      && $mr->filterType != MetaRecord::WINDOWFILTER
	      && $mr->filterType != MetaRecord::SONDERFILTERSEL
			  ){
	      if ($mr->hidden) {
			          ?>	  
<tr><td class="left" title="<?=WSRTranslate::translate('Wertefilter nur für Ausgabe')?>" >*<a 
		href="#<?=$name?>"><?=$name?></a></td><td><?=quoteForHTML($mr->label)?></td>
<td><?=MetaRecord::getKlartextFilter($mr->filterType)?></td>
<td><?=makeDescription($mr)?></td></tr>
<?php  
	      }
	  }
  }
      
  }  // if hasHidden
?>
</table>
<br>
<div class="small">
!n <?=WSRTranslate::translateH('erforderlich: einer der so gekennzeichneten Filter muss im Report gesetzt sein, n ist die Gruppennummer')?>.<br>
* <?=WSRTranslate::translateH('Werte- oder Anzeige-Filter: wird erst auf der Ergebnistabelle angewandt.')?></div>
<?php
if (count($query->defaultFilter) > 0){
    ?>
<h3><?=WSRTranslate::translateH('Default-Filter')?></h3>
<table id="Tabelle4" <?=$border ?>  class="aLeft">
<thead>
<tr><th><?=WSRTranslate::translateH('Name')?></th><th><?=WSRTranslate::translateH('Label')?></th><td>
<th><?=WSRTranslate::translateH('Auswahl')?></th>
</tr>
</thead>
<?php 
foreach ($query->defaultFilter as $df){
    if (false) $df = new DefaultFilter('N');
    $name = $df->column_name;
    $filter = new RepFilter($name);
    $filter->fs_von = $df->fs_von;
    $filter->fs_bis = $df->fs_bis;
    $mr = $query->metaData[$name];
    ?>
<tr><th class="left" ><a href="#<?=$name?>"><?php echo $name;
if ($mr->hidden) echo ' (verborgen)';?></a></th><td><?=quoteForHTML($mr->label)?></td>
<td><?=showFilter($filter, false) ?>
</tr>

<?php
}
?>
</table>
<?php 
    
} // Default Filter

if (count($query->dimensions) > 0){
?>
<h3><?=WSRTranslate::translateH('Dimensionen')?></h3>
<table id="Tabelle4" <?=$border ?>  class="aLeft">
<thead>
<tr><th><?=WSRTranslate::translateH('Name')?></th>
<th><?=WSRTranslate::translateH('phys. Tabelle')?></th>
<th><?=WSRTranslate::translateH('Key')?></th><th colspan=2><?=WSRTranslate::translateH('verknüpft mit')?></th>
</tr>
</thead>
<?php 
// error_log(print_r($query->dimensions,true));
foreach ($query->dimensions as $dim){
    if (false) $dim = new Dimension('N');
?>
<tr>
<th class="left" <?php if ($dim->histType > 0) echo ' rowspan="2" '; ?>>
<a href="./reportClassDef.php?table=<?=$dim->dimName?>" 
	target="RepDatenQuelle2"><?=$dim->dimNr ?>:&nbsp;<?=$dim->dimName ?></a></th>
<td><?=$dim->phys_table ?></td>
<td><?=$dim->dimKey ?></td>
<td><?=$dim->baseKey ?></td>
<td><?php 
    if ($dim->baseDimNr < 0) echo '&nbsp;';
    else echo $dim->baseDimNr.':&nbsp;'.$query->dimensions[$dim->baseDimNr]->dimName;
?>
</td>
</tr>
<?php if ($dim->histType > 0) { ?>
<tr>
<td><?=Query::getHistText($dim->histType) ?></td>
<td><?=HistoryOptions::getKlartext($dim->historyOption) ?></td>
<td colspan="2">&nbsp;</td>
</tr>
<?php
}
}
?>
</table>
<?php 

}
if ($query->addQueries->size() > 0){
?>
<h3><?=WSRTranslate::translateH('Datenquellen zum Verknüpfen')?></h3>
<table id="Tabelle5" <?=$border ?>  class="aLeft">
<?php 
  for ($i = 0; $i < $query->addQueries->size(); $i++){
	  $aq = $query->addQueries->getPos($i);
	  $arq = $aq->getQuery();
	  $csize = count($aq->calcVars);
	  $rs = 1;
	  if ($aq->class_table != $query->class_table) $rs++;
	  if ($csize > 0) $rs += 1 + $csize;
	  if ($arq->histType > 0) $rs ++;
?>	  
<tr><th class="left" rowspan="<?=$rs?>"><a href="./reportClassDef.php?table=<?=$aq->class_table?>" 
	target="RepDatenQuelle2"><?=$arq->class_table?></a></th>
<th class="left top" colspan="2"><?=quoteForHTML($arq->outputTitlePrefix)?></th>
<?php
if ($aq->class_table == $query->class_table) echo "<td>".WSRTranslate::translateH('Quelle mit sich selbst verknüpft.')."</td></tr>\n";
else echo '<td>'.quoteForHTML($arq->table_description)."</td></tr>\n";
if ($aq->class_table != $query->class_table){
    ?>
<tr><th class="left"><?=WSRTranslate::translateH('Physische Tabelle')?></th><td colspan="2"><?=$arq->phys_table ?></td></tr>
<?php 
}
if ($arq->histType > 0){
    ?>
<tr><th class="left" ><?=WSRTranslate::translateH('Historisierung')?></th>
<td class="left" colspan="2" ><?=Query::getHistText($arq->histType)?></td>
<?php
    
}
	if ($csize > 0){
?>
<tr><td class="left" colspan="3"><?=WSRTranslate::translateH('zusätzlich berechnete Werte')?></td></tr>
<?php 		
	
  for ($c = 0; $c < $csize; $c++){
	  $name = $aq->calcVars[$c];
	  $mr = $arq->getReportMetaRecord($name);
	  $f = '';
	  if ($mr->filterType > MetaRecord::NONE) $f = '&nbsp;*F';	  
?>	  
<tr><th class="left" ><a href="#<?=$aq->class_table."$".$name?>"><?=$name?></a><?= $f?></th><td><?=quoteForHTML($mr->label)?></td>
<td><?=makeDescription($mr)?></td></tr>
<?php  }
	}
  }
?>
</table>
<h3><?=WSRTranslate::translateH('Übersicht zu passenden Zeilen')?></h3>
<table id="Tabelle5" <?=$border ?>  class="aLeft">
<thead><tr><th><?=WSRTranslate::translateH('Basisquelle')?></th>
<?php 
for ($i = 0; $i < $query->addQueries->size(); $i++){
    $aq = $query->addQueries->getPos($i);    
    echo '<th>'.$aq->class_table.'</th>';
}
echo "\n</tr></thead>\n";
for ($iz = 0; $iz < count($query->rowVars); $iz++){
    $rn = $query->rowVars[$iz];
    $mr = $query->getReportMetaRecord($rn);
    if ($mr == null){
        echo '<tr><td colspan="'.($query->addQueries->size()+1).'">'.$rn." hat keine Metadaten</td></tr>\n";
        continue;
    }
    if ($mr->hidden) continue;
    echo '<tr><td class="left"><b>'.$rn.'</b> ('.$mr->label.')</td>';
    for ($i = 0; $i < $query->addQueries->size(); $i++){
        $aq = $query->addQueries->getPos($i)->getQuery();
        if (array_search($rn, $aq->rowVars) === false) echo '<td>&nbsp;</td>';
        else echo '<th class="center">&rArr;</th>';
    }
    echo "</tr>\n";
}
?>
</table>
<h3><?=WSRTranslate::translateH('Übersicht zu passenden Filter')?></h3>
<table id="Tabelle6" <?=$border ?>  class="aLeft">
<thead><tr><th><?=WSRTranslate::translateH('Basisquelle')?></th>
<?php 
for ($i = 0; $i < $query->addQueries->size(); $i++){
    $aq = $query->addQueries->getPos($i);    
    echo '<th>'.$aq->class_table.'</th>';
}
echo "\n</tr></thead>\n";
foreach ($query->metaData as $name => $mr){
    if ($mr->filterType != MetaRecord::NONE){
        $label = $mr->label;
        if ($mr->hidden) $label .= ' - '.WSRTranslate::translate('verborgen');
        echo '<tr><td class="left"><b>'.$name.'</b> ('.$label.')</td>';
        
    for ($i = 0; $i < $query->addQueries->size(); $i++){
        $aq = $query->addQueries->getPos($i)->getQuery();
        if (array_key_exists($name, $aq->metaData)
            && $aq->metaData[$name]->filterType != MetaRecord::NONE)
            echo '<th class="center">&rArr;</th>';
            else  echo '<td>&nbsp;</td>';
    }
    echo "</tr>\n";
    }
}
?>
</table>
    



<?php 
} // addQueries


if ($query->queryType == Query::DIMENSION){
    $sql = new SqlAbfrage('WSR');
    $sql->sql = "select t.table_name, t.attribute as label, h.attribute as histType from queryAttribute t";
    $sql->sql .= " left join queryAttribute h on h.table_name = t.table_name and h.SatzTyp = '11'";     
    $sql->addWhere('t.SatzTyp = 2');
    $sql->sql .= ' and t.table_name in (select table_name from  queryDimensions where ';
    $sql->addKlausel('qDimName = ' , $query->class_table);
    $sql->sql.=') order by t.table_name';
    
    $hasRows = false;
    if ($stmt = $sql->execute()){
        while($z = $stmt->fetchObject()){
            if (! $hasRows){
?>
<h3><?=WSRTranslate::translateH('Die Dimension wird verwendet von')?></h3>		
<table id="Tabelle6" <?=$border ?>  class="aLeft">
<thead><tr><th><?=WSRTranslate::translateH('interner Name')?></th>
<th><?=WSRTranslate::translateH('Label')?></th><th><?=WSRTranslate::translateH('Historisierung')?></th></tr></thead>
<tbody>
<?php
        $hasRows = true;
        }
?>
<tr><th class="left"><a href="./reportClassDef.php?table=<?=$z->table_name?>" 
	target="RepDatenQuelle2"><?=$z->table_name ?></a></th><td><?=$z->label ?></td>
	<td><?php if ($z->histType > 0) echo Query::getHistText($z->histType); ?></td>
	</tr>
<?php 
    }
}
if ($hasRows){
?>
</tbody>
</table>  
<?php 
}
}
// Verwendung der Dimension
?>
		

<?php 
// Verwendung in anderen Quellen
$sql = new SqlAbfrage('WSR');
$sql->sql = "select t.table_name, t.attribute as label from queryAttribute t";
$sql->addWhere('SatzTyp = 2');
$sql->sql .= ' and table_name in (select table_name from  queryAttribute where ';
$sql->addKlausel('SatzTyp >= 100 and attribute = ' , $query->class_table);
$sql->sql.=') order by table_name';

$hasRows = false;
if ($stmt = $sql->execute()){
    while($z = $stmt->fetchObject()){
        if (! $hasRows){
?>
<h3><?=WSRTranslate::translateH('Die Datenquelle wird verwendet von')?></h3>		
<table id="Tabelle6" <?=$border ?>  class="aLeft">
<thead><tr><th><?=WSRTranslate::translateH('interner Name')?></th><td>
<th><?=WSRTranslate::translateH('Label')?></th></tr></thead>
<tbody>
<?php
        $hasRows = true;
        }
?>
<tr><th class="left"><?=$z->table_name ?></th><td><?=$z->label ?>
<?php 
    }
}
if ($hasRows){
?>
</tbody>
</table>
<?php 
}
?>
</div>

<?php 

// Variablen einzeln

  for ($i = 0; $i < count($query->rowVars); $i++){
	  $name = $query->rowVars[$i];
	  $mr = $query->getReportMetaRecord($name);
?>
<div class="kommentar">
<h4 id="<?=$name?>"><?=$name?>: <?=quoteForHTML($mr->label)?><?php if ($mr->hidden) echo ' (verborgen)'; ?></h4>
<table <?=$border?> class="aLeft">	  
<tr><th class="left" ><?=WSRTranslate::translateH('Beschreibung')?></th>
<td><?=makeDescription($mr)?></td></tr>
<tr><th class="left" >Typ</th>
<td><?php echo MetaRecord::getKlartextType($mr->type);
if (($mr->type == MetaRecord::DECIMAL || $mr->type == MetaRecord::GELD)
    && $mr->decimals > 0) echo ' - '.$mr->decimals.' Nachkommastelle(n)';?></td></tr>
<?php 
if (isValid($mr->align)){
    ?>
<tr><th class="left" ><?=WSRTranslate::translateH('Anzeige')?></th>
<td><?=$mr->htmlData.' '. $mr->align?></td></tr>
<?php 
	  }
?>    
<tr><th class="left" >Select</th>
<td><?=$mr->selectVar?></td></tr>
<?php 
	if (isValid($mr->displayVar) &&  $mr->selectVar != $mr->displayVar){
?>
<tr><th class="left nowrap" ><?=WSRTranslate::translateH('abweichende Anzeige')?></th>
<td><?=$mr->displayVar?></td></tr>
<?php 
	}
displayFilterDef($mr);

if ($mr->dimNr >= 0){
    $dim = $query->dimensions[$mr->dimNr];
    ?>
<tr><th class="left nowrap" ><?=WSRTranslate::translateH('aus Dimension')?></th>
<td><?=$mr->dimNr?>:&nbsp;<?=$dim->dimName ?> (<?=$dim->baseKey ?>)</td></tr>
<?php 
if (count($mr->reqDim) > 0){
?>    
    <tr><th class="left nowrap" ><?=WSRTranslate::translateH('benötigte Dimensionen')?></th><td>
<?php     
$reqDim = $mr->reqDim;
arsort($reqDim);
foreach ($reqDim as $dNr){
        $dim = $query->dimensions[$dNr];
        ?>
<?=$dNr?>:&nbsp;<?=$dim->dimName ?> (<?=$dim->baseKey ?>)<br>
<?php             
    }
    ?>
</td></tr>
<?php     
}
}
?>
</table>
</div>
<?php  } ?>
<?php 
  for ($i = 0; $i < count($query->valueVars); $i++){
	  $name = $query->valueVars[$i];
	  $mr = $query->getReportMetaRecord($name);
?>
<div class="kommentar">
<h4 id="<?=$name?>"><?=$name?>: <?=quoteForHTML($mr->label)?><?php if ($mr->hidden) 
    echo ' ('.WSRTranslate::translateH('verborgen').')'; ?></h4>
<table <?=$border?> class="aLeft">	  
<?php 	  
	  if ($mr->enterValue){
?>	  
<tr><th class="left" colspan = "2"><?=WSRTranslate::translateH('Eingabefeld')?></th>
<?php 
	  }
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Beschreibung')?></th>
<td><?=makeDescription($mr)?></td></tr>
<tr><th class="left" >Typ</th>
<td><?php echo MetaRecord::getKlartextType($mr->type);
if (($mr->type == MetaRecord::DECIMAL || $mr->type == MetaRecord::GELD)
    && $mr->decimals > 0) echo ' - '.$mr->decimals.' '.WSRTranslate::translateH('Nachkommastelle(n)');?></td></tr>
<?php 
if (isValid($mr->align) && $mr->align != 'right'){
    ?>
<tr><th class="left" ><?=WSRTranslate::translateH('Ausrichtung')?></th>
<td><?=$mr->align?></td></tr>
<?php 
	  }
?>
<tr><th class="left" >Select</th>
<td><?=$mr->selectVar?></td></tr>
<?php 	  
if ($mr->enterValue){
?>	  
<tr><th class="left" ><?=WSRTranslate::translateH('Eingabe in')?></th>
<td><?=$mr->qSetVarname?></td></tr>
<?php 
	  }
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Chart-Farben')?></th>
<td><?=$mr->chartColor?> / <?=$mr->chartNegColor?></td></tr>
<?php 
if (isValid($mr->chartGroup)){
	?>
<tr><th class="left" ><?=WSRTranslate::translateH('Chart-Gruppe')?></th>
<td><?=$mr->chartGroup?></td></tr>
<?php }
displayFilterDef($mr);

?>
</table>
</div>
<?php  } // for .. ValueVars ?>
<?php 
  for ($i = 0; $i < count($query->filterVars); $i++){
	  $name = $query->filterVars[$i];
	  $mr = $query->getReportMetaRecord($name);
?>	  
<div class="kommentar">
<h4 id="<?=$name?>"><?=$name?>: <?=quoteForHTML($mr->label)?><?php if ($mr->hidden) echo ' (verborgen)'; ?></h4>
<table <?=$border?> class="aLeft">	  
<tr><th class="left" ><?=WSRTranslate::translateH('Beschreibung')?></th>
<td><?=makeDescription($mr)?></td></tr>

<?php 
	
displayFilterDef($mr);
if ($mr->dimNr >= 0){
    $dim = $query->dimensions[$mr->dimNr];
    ?>
<tr><th class="left nowrap" ><?=WSRTranslate::translateH('aus Dimension')?></th>
<td><?=$mr->dimNr?>:&nbsp;<?=$dim->dimName ?> (<?=$dim->baseKey ?>)</td></tr>
<?php 
if (count($mr->reqDim) > 0){
?>    
    <tr><th class="left nowrap" ><?=WSRTranslate::translateH('benötigte Dimensionen')?></th><td>
<?php     
$reqDim = $mr->reqDim;
arsort($reqDim);
foreach ($reqDim as $dNr){
        $dim = $query->dimensions[$dNr];
        ?>
<?=$dNr?>:&nbsp;<?=$dim->dimName ?> (<?=$dim->baseKey ?>)<br>
<?php             
    }
    ?>
</td></tr>
<?php     
}
}
?>

</table>
</div>
<?php  
  } // for .. filter
for ($i = 0; $i < $query->addQueries->size(); $i++){
    $aq = $query->addQueries->getPos($i);
    $arq = $aq->getQuery();
    $csize = count($aq->calcVars);
    if ($csize > 0){
        echo '<h3>'.$arq->outputTitlePrefix.' ('.$arq->class_table.')</h3>' ;
        for ($c = 0; $c < $csize; $c++){
            $name = $aq->calcVars[$c];
            $mr = $arq->getReportMetaRecord($name);
            

?>

<div class="kommentar">
<h4 id="<?=$aq->class_table."$".$name?>"><?=$aq->class_table?>$<?=$name?>: <?=quoteForHTML($mr->label)?></h4>
<table <?=$border?> class="aLeft">	  
<tr><th class="left" ><?=WSRTranslate::translateH('Beschreibung')?></th>
<td><?=makeDescription($mr)?></td></tr>
<tr><th class="left" >Typ</th>
<td><?php echo MetaRecord::getKlartextType($mr->type);
if (($mr->type == MetaRecord::DECIMAL || $mr->type == MetaRecord::GELD)
    && $mr->decimals > 0) echo ' - '.$mr->decimals.' '.WSRTranslate::translateH('Nachkommastelle(n)');?></td></tr>
<?php 
if ($mr->filterType > MetaRecord::NONE) {
?>             
<tr><th class="left" >Filter-Typ</th>
<td><?=MetaRecord::getKlartextFilter($mr->filterType)?></td></tr>
<?php 
}
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Berechnung')?></th>
<td><?=$mr->selectVar?></td></tr>
<tr><th class="left" ><?=WSRTranslate::translateH('Chart-Farben')?></th>
<td><?=$mr->chartColor?> / <?=$mr->chartNegColor?></td></tr>
<?php 
if ($mr->chartGroup != null){
	?>
<tr><th class="left" ><?=WSRTranslate::translateH('Chart-Gruppe')?></th>
<td><?=$mr->chartGroup?></td></tr>
<?php 
}
?>
</table>
</div>
<?php 
  		}
  	}  
  }

?>

<footer class="leiste">
<div class="Fleft">WS Reporting Version <?=$wsReportVersion?></div>
<div class="Fright right">&copy; WS Unternehmensberatung</div>
</footer>
</body>
</html>
</body>
</html>
