<?php 
/**
 * Projekt: WS-Reporter
 *          Report-Definition ausgeben
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    21.2.2023 MS
 *
 */
include 'includes/defender.inc';
// Ausgabe der Report-Definition
global $query;
require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
require_once './includes/createReport.inc';
global $query, $user, $wsReportVersion;

$border ="";
if (false) $query = new Query("dummy");
$query = null;
if (session_status() == PHP_SESSION_NONE)  session_start();

anmeldungPruefen();

if (array_key_exists('WSReportQuery', $_SESSION)){
    $query = $_SESSION['WSReportQuery'];
}
session_write_close();
if (array_key_exists('report', $_REQUEST)){
    if ($query == null || $query->title != $_REQUEST['report']){
        require_once './includes/loadReportDef.inc';
        loadReport($_REQUEST['report']);
    }
}
if ($query == null || $query->title != $_REQUEST['report']){
    echo WSRTranslate::translate("FEHLER:<br>Die Report-Defintion")." ".$_REQUEST['report']
    ." ".WSRTranslate::translate("konnte nicht geladen werden.");
    die();
}
if (false){
    $query = new Query("tab");
    $rq = new Query("tab");
    $jquery = new Query("tab");
    $mr = new MetaRecord();
//    $mr2 = new MetaRecord();
//    $mrf = new MetaRecord();
    $jt = new JoinedTable(null);
    $jtk = new JoinedTable(null);
}
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title><?=$query->outputTitlePrefix.': '.WSRTranslate::translate('Dokumentation von')
   .' '.quoteForHTML($query->title)?></title>
<meta name="GENERATOR" content="WS-PHP: showSQL.php">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="<?=$query->reportCSS ?>" >
</head> 
<?php 
if ($_SERVER["HTTP_HOST"] == "localhost:8898") echo '<body class="entwicklung">';
else echo '<body>';
?>
<h1><?=WSRTranslate::translateH('Report-Dokumentation von').' '.quoteForHTML($query->title)?></h1>
<?php 
leseRechteVerlangen();
?>

<div class="kommentar2">
<h3><?=WSRTranslate::translateH('Global')?></h3>


<table id="Tabelle" <?=$border?> class="aLeft">
<?php
$erfassung = false;
if($query->queryType > Query::DATEN){   
    for ($i=0; $i < $query->repValues->size(); $i++){
        if ($query->getReportMetaRecord($query->repValues->getPos($i)->getName())->enterValue) $erfassung = true;
    }
    if ($erfassung){
?>	
<tr><th class="left" ><?=WSRTranslate::translateH('Erfassungstabelle')?></th><td><?=$query->getTypeText($query->queryType) ?></td></tr>
<?php }} ?>
<tr><td class="left" colspan="2"><?=quoteForHTML($query->kommentar)?></td></tr>
<?php if (isValid($query->report_hints)){?>	
<tr>
<td class='left' colspan='2'><?=quoteForHTML($query->report_hints)?></td></tr>
<?php
}
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Datenquelle (Basis)')?></th>
<td><a href="./reportClassDef.php?table=<?=$query->class_table?>" target="RepDatenQuelle"
	><?=$query->outputTitlePrefix?><!--  (<?=$query->class_table?>) --></a></td></tr>
<?php if (isValid($query->table_hints)){?>	
<tr><th class="left" ><?=WSRTranslate::translateH('Technische Hinweise')?></th>
<td><?=quoteForHTML($query->table_hints)?></td></tr>
<?php
}

// Administrative Informationen
if ($query->reportImported){
    if (isValid($query->importUserCreated)){
        ?>
<tr><th class="left"><?=WSRTranslate::translateH('Erstellt von') ?></th>
<td><?=$query->importUserCreated?>
(<?=WSRFormats::formatDateTime(DateTime::createFromFormat('Y-m-d H:i:s',$query->importTimeCreated)) ?>)</td></tr>    
<?php         
    }
    if (isValid($query->importUserReleased)){
        ?>
<tr><th class="left"><?=WSRTranslate::translateH('Freigegeben von') ?></th>
<td><?=$query->importUserReleased?> 
(<?=WSRFormats::formatDateTime(DateTime::createFromFormat('Y-m-d H:i:s',$query->importTimeReleased)) ?>)</td></tr>    
<?php         
    }
}else if ($query->reportID > 0){
    $logSql = new SqlAbfrage('WSR');
    $logSql->sql = 'select * from wsrAdminReport';
    $logSql->addSel('reportID = ', $query->reportID);
    $stmt = $logSql->execute();
    $z = $stmt->fetchObject();
    if (isValid($z->userCreated)){
?>    
<tr><th class="left"><?=WSRTranslate::translateH('Erstellt von') ?></th>
<td><?=$z->userCreated ?> (<?=WSRFormats::formatDateTime(DateTime::createFromFormat('Y-m-d H:i:s',$z->timeCreated)) ?>)</td></tr>    
<?php         
    }
    if (isValid($z->userStored)){
        ?>
<tr><th class="left"><?=WSRTranslate::translateH('Zuletzt gespeichert von') ?></th>
<td><?=$z->userStored ?> (<?=WSRFormats::formatDateTime(DateTime::createFromFormat('Y-m-d H:i:s',$z->timeStored)) ?>)</td></tr>    
<?php         
    }
    if (isValid($z->userReleased)){
        ?>
<tr><th class="left"><?=WSRTranslate::translateH('Freigegeben von') ?></th>
<td><?=$z->userReleased ?> (<?=WSRFormats::formatDateTime(DateTime::createFromFormat('Y-m-d H:i:s',$z->timeReleased)) ?>)</td></tr>    
<?php         
    }
    if (isValid($z->userResponsible)){
        ?>
<tr><th class="left"><?=WSRTranslate::translateH('Verantwortlich') ?></th>
<td><?=$z->userResponsible ?></td></tr>    
<?php         
    }
    
}

// Ende Administrative Informationen
?>
<tr><th class="left"><?=WSRTranslate::translateH('Sprache(n)') ?></th>
<td><?php echo $query->rLanguage.' '; foreach ($query->rTranslations as $t) echo $t.' ' ?></td></tr>    

<?php

if ($query->repTables->size() > 0){ ?>	
<tr><th class="left" rowspan = "<?=$query->repTables->size()?>"><?=WSRTranslate::translateH('verknüpfte Daten')?></th>
<?php for ($j=0; $j < $query->repTables->size(); $j++ ) {
	$jt = $query->repTables->getPos($j);
	$rq = $jt->query;
	if ($j > 0) echo "<tr>";
?>
<td><a href="./reportClassDef.php?table=<?=$rq->class_table?>" target="RepDatenQuelle"
	><?=$rq->outputTitlePrefix ?><!--  (<?=$rq->class_table?>) --></a> (<?=JoinedTable::klartext[$jt->joinType] ?>)
	 <b><?php if (isValid($jt->prefix)) echo $jt->prefix; else  echo $jt->kennzeichen;?></b> </td>
</tr>	
<?php } ?>		
<?php }

if($query->fix_labelColumns){
?>	
<tr><th class="left" ><?=WSRTranslate::translateH('Zeilen-Label')?></th><td><?=WSRTranslate::translateH('fixieren')?></td></tr>
<?php } 
if($query->dropSummen){
    ?>
<tr><th class="left" ><?=WSRTranslate::translateH('Summenzeilen')?></th>
<td><?=WSRTranslate::translateH('redundante Summenzeilen leer lassen')?></td></tr>
<?php } 
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Sortieren')?></th><td><?=SortOptions::klartext[$query->sort_mode]?></td></tr>
<?php
if ($query->folderMode > 0){
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Auf- und zuklappen')?></th>
<td><?=Query::getFolderText($query->folderMode)?></td></tr>
<?php
}
?>
<tr><th class="left" ><?=WSRTranslate::translateH('Charts anzeigen')?></th><td><?=ChartOptions::klartext[$query->display_charts]?></td></tr>
<tr><th class="left" ><?=WSRTranslate::translateH('Chart-Größe')?></th><td><?=$query->chart_size?></td></tr>
<?php  
/****
 * Anzeige der Geld-Einheiten
 */

switch ($query->repGeldFaktor){
    case 0.001: echo "<tr><th class=\"left\">".WSRTranslate::translateH('Geldwerte')
    ."</th><td>".WSRTranslate::translateH('Geldangaben in Tsd.€')."</td></tr>\n";
    break;
    case 0.000001: echo "<tr><th class=\"left\">".WSRTranslate::translateH('Geldwerte')
    ."</th><td>".WSRTranslate::translateH('Geldangaben in Mio.€')."</td></tr>\n";
    break;
    default: break;
}
?>	
</table>
<p>
<?php 
if ($erfassung){
?>
<h3><?=WSRTranslate::translateH('Erfasste Werte')?></h3>
<table id="Tabelle0" <?=$border?>  class="aLeft">
<thead>
<tr><th><?=WSRTranslate::translateH('Wert')?></th><th><?=WSRTranslate::translateH('Beschreibung')?></th></tr>
<tr>
</thead>
<?php
  for ($i = 0; $i < $query->repValues->size(); $i++){
	  $name = $query->repValues->getPos($i)->getName();
	  $mr = $query->getReportMetaRecord($name);
	  if (!$mr->enterValue) continue;
	  $label = $mr->label;
	  if (substr($name,1,1) == ":" || substr($name,1,1) == "="){
	      $jtp = $query->repTables->get(substr($name,0,1))->prefix;	      
	      if (isValid($jtp)){
	          if (substr($jtp,strlen($jtp)-1) == ':') $jtp = substr($jtp,0,strlen($jtp)-1);	          
		      $label = "<i>".$jtp."</i>".substr($name,1,1)." ".$label;
	      }
		  else $label = substr($name,0,2).$label;
	  }	  
?>	  
<tr><th class="left" ><?=$label?></th>
<td><?php echo makeDescription($mr); 
if ($query->repValues->getPos($i)->keineSummen) 
    echo '<br>('.WSRTranslate::translateH('Keine Werte für Insgesamt-Zeilen').')';?></td>
</tr>
<?php } ?>
</table>
<?php
} // erfassung

//Die Filterübersicht muss bei Joins am Anfang stehen
  $filterListe = array();

 if ($query->repTables->size() > 0){
     // Liste der Filternamen, damit Filter aus verschiedenen Quellen
     // in derselben Zeile angezeigt werden. 
	  for ($fi=0; $fi< $query->repFilter->size(); $fi++){
		  $fName =  $query->repFilter->getPos($fi)->getName();
		  $mr = $query->getReportMetaRecord($fName);
		  if (substr($fName,1,1) == ":"){
			  $fName = substr($fName, 2);
		  }
		  if (false === array_search($fName,$filterListe)){ 
			  $filterListe[] = $fName ;
		  }
	  }	
?>	 
 <h3><?=WSRTranslate::translateH('Filter-Übersicht')?></h3>
<div class = 'small'>(<?=WSRTranslate::translateH('ohne Anzeige-Filter')?>)</div> 
<table id="Tabelle3" <?=$border?>  class="aLeft">
<thead>
<tr><th><?=WSRTranslate::translateH('Filter')?></th><th><?=WSRTranslate::translateH('ausgewählt')?></th>
<?php 
 for ($j = 0; $j < $query->repTables->size(); $j++){
	$jt = $query->repTables->getPos($j);
	if (isValid($jt->prefix)) echo "<th>".$jt->prefix."</th>"; else  echo "<th>".$jt->kennzeichen."</th>";	
}
?> 
</tr></thead>
<?php 

for ($fi = 0; $fi < count($filterListe); $fi++){
	$fName = $filterListe[$fi];
	$inBase = $query->repFilter->has($fName);
	$mr = null;	
	if ($inBase){
	    $filter = $query->repFilter->get($fName);
	    if ($filter->isWindowFilter()) continue;
	    if ($filter->isValueFilter()) continue;
	    $mr = $query->getReportMetaRecord($fName);
	}
	else 
	for ($mi=0; $mi < $query->repTables->size() && $mr == null; $mi ++)
	    if ($query->repFilter->has($query->repTables->getPos($mi)->kennzeichen.':'.$fName)){
	        $mr = $query->getReportMetaRecord($query->repTables->getPos($mi)->kennzeichen.':'.$fName);
	        $filter = $query->repFilter->get($query->repTables->getPos($mi)->kennzeichen.':'.$fName);
	        if ($filter->isWindowFilter()) continue 2;
	        if ($filter->isValueFilter()) continue 2;
	}
	
	if ($mr == null){
	    $mr = new MetaRecord();
	    $mr->label = WSRTranslate::translateH('Keine Metadaten für').' '.$fName;
    }
	?>
<tr><th class="left"><?=quoteForHTML($mr->label)?></th>
<?php 
if ($inBase){
    $fText = showFilter($query->repFilter->get($fName), false);
    if ($fText == null)
		echo "<td class=\"center\">&dArr;</td>";
	else
		echo "<td>".$fText."</td>";
	}
else echo "<td class=\"center\">&nbsp;</td>";

	for ($j = 0; $j < $query->repTables->size(); $j++){
	$jtk = $query->repTables->getPos($j)->kennzeichen;
	$jquery = $query->repTables->getPos($j)->query;
	if ($query->repFilter->has($jtk.":".$fName)){
	    $fText = showFilter($query->repFilter->get($jtk.":".$fName), false);
	    if ($fText != null) echo "<td class=\"center\">".$fText."</td>";
	    else echo "<td class=\"center\">&empty;</td>";	    
	}else if ($inBase){
	    if (array_key_exists($fName, $jquery->metaData)
	        &&  $jquery->getReportMetaRecord($fName)->filterType != MetaRecord::NONE)
	        echo "<td class=\"center\">&rArr;</td>";
	        else echo "<td class=\"center\">&otimes;</td>";
	}else echo "<td class=\"center\">&nbsp;</td>";
}
?>
</tr>
	<?php	
} // Schleife Filter-Liste
?>
 
</table>
<div class="small">
<b><?=WSRTranslate::translateH('Symbole')?>:</b><br>
&dArr;: <?=WSRTranslate::translateH('wird aus Link-Aufruf übernommen')?><br>
&rArr;: <?=WSRTranslate::translateH('wird aus Basisquelle übernommen')?><br>
&otimes;: <?=WSRTranslate::translateH('gesperrt, kein Filter bei dieser Datenquelle')?><br>	 
&empty;: <?=WSRTranslate::translateH('gesperrt durch leeren Filter-Eintrag')?><br>
(<?=WSRTranslate::translateH('leer')?>): <?=WSRTranslate::translateH('kein Filter in der Basisquelle')?>
</div>
<?php	 
 } // Filter-Übersicht
 
 /**
  * Historisierung
  */
 if ($query->histType > 0){
     $showHistQueryDate = false;
     if (isset($entwicklung) || $_SESSION['globalAdmin'] )
         $showHistQueryDate = true;
         if ($showHistQueryDate) {
            require_once './includes/createReport.inc';
            createHistory();
         }
?>
<h3><?=WSRTranslate::translateH('Historisierung')?></h3>
<table id="TabelleH" <?=$border?> class="aLeft">
<thead>
<tr><th><?=WSRTranslate::translateH('Datenquelle')?></th>
<th><?=WSRTranslate::translateH('Dimension')?></th>
<th><?=WSRTranslate::translateH('Typ')?></th><th><?=WSRTranslate::translateH('Auswahl / Stichtag')?></th>
<?php if ($showHistQueryDate) echo '<th>'.WSRTranslate::translateH('Ergebnis').'</th>' ?>
</tr>
</thead>
<tbody>
<th class='left' colspan='2'><?=WSRTranslate::translateH('Basis:')?> (<?=$query->outputTitlePrefix ?>)</th>
<td><?=Query::getHistText($query->histType) ?></td>
<td><?php if ($query->historyOption) echo HistoryOptions::getKlartext($query->historyOption);
else echo '&nbsp;';?>
<?php if ($query->historyOption == HistoryOptions::HSDATUM && isValid($query->historyDate)) 
    echo '  '.WSRFormats::formatDate(DateTime::createFromFormat('Y-m-d', $query->historyDate));
    ?>
</td>
<?php if ($showHistQueryDate)
    if ($query->histType == Query::STICHTAG) echo '<td>&nbsp;</td>' ;
else echo '<td>'.$query->historyQueryDate.'</td>' ?>
</tr>
<?php 
foreach($query->dimensions as $nr => $dim){
    if (false) $dim = new Dimension(null);
    if ($dim->histType > 0){
        if (! $query->reportHasDim('base', $nr) ) continue;
            ?>
<tr><td>&nbsp;</td><td><?=$dim->dimName ?></td><td><?=Query::getHistText($dim->histType)?></td>
<td>
<?php 
    if ($dim->historyOption == HistoryOptions::HSUEBERNEHMEN){
          echo '&dArr; ';
          echo HistoryOptions::getKlartext($query->historyOption);
    }
    else {
        echo HistoryOptions::getKlartext($dim->historyOption) ;
        if ($dim->historyOption == HistoryOptions::HSDATUM && isValid($dim->historyDate)) 
            echo '  '.WSRFormats::formatDate(DateTime::createFromFormat('Y-m-d', $dim->historyDate));
    }
    ?>
</td>
<?php if ($showHistQueryDate) echo '<td>'.$dim->historyQueryDate.'</td>' ?>
</tr>
<?php
    }
}
for ($tc = 1; $tc <= $query->repTables->size(); $tc++){
    
    $repTable = $query->repTables->getPos($tc-1);
    if (false) $repTable = new JoinedTable(null);
    $tQuery = $repTable->query;
    if ($tQuery->histType == 0) continue;
?>
    <th class='left' colspan='2'><?=$repTable->prefix ?> (<?=$tQuery->outputTitlePrefix ?>)</th>
<td><?=Query::getHistText($tQuery->histType) ?></td>
<td><?php 
if ($repTable->dimHistoryOption[0] == HistoryOptions::HSUEBERNEHMEN){
    echo '&dArr; ';
    echo HistoryOptions::getKlartext($query->historyOption);
}
else echo HistoryOptions::getKlartext($repTable->dimHistoryOption[0]); 
    if ($repTable->dimHistoryOption[0] == HistoryOptions::HSDATUM && isValid($repTable->dimHistoryDate[0])) 
        echo '  '.WSRFormats::formatDate(DateTime::createFromFormat('Y-m-d', $repTable->dimHistoryDate[0]));
    ?>
</td>
<?php if ($showHistQueryDate) 
    if ($tQuery->histType == Query::STICHTAG) echo '<td>&nbsp;</td>' ;
    else echo '<td>'.$repTable->dimHistoryQueryDate[0].'</td>' ?>
</tr>
<?php
foreach($repTable->query->dimensions as $nr => $dim){
    if ($dim->histType == 0) continue;
    if (! $query->reportHasDim($repTable->kennzeichen , $nr)) continue;
//    if ($repTable->dimHistoryOption[$nr] == HistoryOptions::HSUEBERNEHMEN) continue;
        
?> 
<tr><td>&nbsp;</td><td><?=$dim->dimName ?></td><td><?=Query::getHistText($dim->histType)?></td>
<td>

<?php 
    if ($repTable->dimHistoryOption[$nr] == HistoryOptions::HSUEBERNEHMEN){
          echo '&dArr; ';
          echo HistoryOptions::getKlartext($repTable->dimHistoryOption[0]);
    }
    else {
        echo HistoryOptions::getKlartext($repTable->dimHistoryOption[$nr]) ;
        if ($repTable->dimHistoryOption[$nr] == HistoryOptions::HSDATUM && isValid($repTable->dimHistoryDate[$nr])) 
            echo '  '.WSRFormats::formatDate(DateTime::createFromFormat('Y-m-d', $repTable->dimHistoryDate[$nr]));
    }
    ?>
</td>
<?php if ($showHistQueryDate) echo '<td>'.$repTable->dimHistoryQueryDate[$nr].'</td>' ?>
</tr>
<?php 


?> 
    
<?php     
}// foreach dim
}// foreach repTables
?>
</tbody>
</table>
<div class="small">
<b><?=WSRTranslate::translateH('Symbole')?>:</b><br>
&dArr;: <?=WSRTranslate::translateH('wird aus Quelle bzw. Basisquelle übernommen')?><br>
(<?=WSRTranslate::translateH('leer')?>): <?=WSRTranslate::translateH('kein Historisierung spezifizert')?>
</div>

<?php 
 } // Ende Historisierung
?>
<p>
<h3><?=WSRTranslate::translateH('Zeilen')?></h3>
<table id="Tabelle1" <?=$border?> class="aLeft">
<thead>
<tr><th><?=WSRTranslate::translateH('Zeilen-Var.')?></th><th><?=WSRTranslate::translateH('Sortierung')?></th>
<th><?=WSRTranslate::translateH('Summen-<br>zeile')?></th>
<th><?=WSRTranslate::translateH('Label')?><br><?=WSRTranslate::translateH('fix.')?></th>
<th><?=WSRTranslate::translateH('Web-Link')?></th><th><?=WSRTranslate::translateH('Filter<br>übern.')?></th>
<th><?=WSRTranslate::translateH('Beschreibung')?></th></tr>
<tr>
</thead>
<?php
$row = new RepRow('NN');
    for ($i = 0; $i < $query->repRows->size(); $i++){
      $row = $query->repRows->getPos($i);
      $name = $row->getName();
      if ($row->webLinkColumn){
          $mr = new MetaRecord();
          $mr->description = $row->web_title;
      }else $mr = $query->getReportMetaRecord($name);
?>	  
<tr>
<?php 
if ($row->webLinkColumn){    
?>
	<th class="left"><?=quoteForHTML($row->web_link_title)?>
	   <br><span class="nowrap">(Link-Spalte: <?= quoteForHTML($row->web_link_value)?>)</span>
	</th>
<?php 
}else{
?>
	<th class="left"><?=quoteForHTML($mr->label)?></th>
<?php
}
?>
<td><?php if ($row->sort > Sort::NONE) echo Sort::klartext[$row->sort]; else echo "&nbsp;"; ?></td>

<td class="center"><?php if ($row->summenZeilen) echo "X"; else echo "&nbsp;"; ?></td>

<td class="center"><?php if ($row->fixedTableColumns) echo "X"; else echo "&nbsp;"; ?></td>

<td><?php if (isValid($row->web_link)){
    echo $row->web_link;
    if (substr($row->web_link, 0,1) == '#'){
        $mrl = $query->getReportMetaRecord(substr($row->web_link, 1));
        if (false) $mrl = new MetaRecord();
        if ($mrl != null){            
            if (isValid($mrl->displayVar))  echo '<br>('.quoteForHTML($mrl->displayVar).')';
            else
                if (isValid(makeDescription($mrl)))  echo '<br>('.makeDescription($mrl).')';
                else
                    if (isValid($mrl->label))  echo '<br>('.quoteForHTML($mrl->label).')';
                    else if (isValid($row->web_title)) echo '<br>('.quoteForHTML($row->web_title).')';
        }
    } 
    if (isValid($row->web_target)) echo "\n<br>_Target=".$row->web_target;
}else echo "&nbsp;"; ?></td>

<td class="center"><?php if ($row->webCopyFilter) echo "X"; else echo "&nbsp;"; ?></td>

<td><?=makeDescription($mr)?></td>
</tr>
<?php } // repRows 
?>
</table>

<?php

	if ($query->values_in_columns) {
		echo "<br><b>".WSRTranslate::translateH('Werte in Spalten').':</b> '
        .WSRTranslate::translateH('Die Wertenamen stehen' 
			.' in einer zusätzlichen Spalte und die Werte stehen untereinander.') ;
			if (isValid($query->valueColumnFolderMode)){
			    if ($query->valueColumnFolderMode == 'WSFHeader') 
                    echo "\n<br>".WSRTranslate::translateH('Beim Zuklappen wird der erste Wert angezeigt');
			    else
                if ($query->valueColumnFolderMode == 'WSFSummen') 
                    echo "\n<br>".WSRTranslate::translateH('Beim Zuklappen wird der letzte Wert angezeigt');
			}
		
	if ($query->repColumns->size() > 0){
?>		
<p><h3><?=WSRTranslate::translateH('Spalten')?></h3>
<table id="TabelleS" <?=$border?>  class="aLeft">

<?php	
for ($i = 0; $i < $query->repColumns->size(); $i++){
	$rc = $query->repColumns->getPos($i);
	$mr = $query->getReportMetaRecord($rc->getName());
	if ($mr != null) $colLabel = $mr->label;
	else $colLabel = WSRTranslate::translateH('FEHLER: Keine Metadaten für').' '.$rc->getName();
	
	$rowSpan = 1;
	if ($rc->sort > Sort::NONE) $rowSpan ++;
	if (isValid($rc->filter)) $rowSpan += 2;
	if (isValid($rc->web_link)) $rowSpan += 2; 
	?>
	<tr><th class="top left" rowspan = "<?=$rowSpan?>"><?=quoteForHTML($colLabel)?></th>
	<th class = "left">Label</th><td><?=quoteForHTML($rc->label)?></td></tr>
<?php  
	if ($rc->sort > 0) echo"<tr><th class = \"left\">"
            .WSRTranslate::translateH('Sortierung').'</th><td>'.Sort::getKlartext($rc->sort)."</td></tr>\n";
	if (isValid($rc->filter)) {
	    $mr = $query->getReportMetaRecord($rc->filter);	    
		if ($mr != null) echo "<tr><th class = \"left\" rowspan=\"2\">Filter</th><td"
                                .makeTitle(makeTitleDescription($mr)).">".$mr->label."</td></tr>\n";
		else echo "<tr><th class = \"left\" rowspan=\"2\">"
                .WSRTranslate::translateH('Filter')."</th><td>".$rc->filter." "
                .WSRTranslate::translateH('OHNE NETADATEN')."</td></tr>\n";
		$filter = new RepFilter($rc->filter);
		$filter->fs_von = $rc->fs_von;
		$filter->fs_bis = $rc->fs_bis;
		$fst = showFilter($filter, false);
		if ($fst == null) echo "<tr><td>&lt;&lt;".WSRTranslate::translateH('nicht gesetzt')."&gt;&gt;</td></tr>\n";
		echo "<tr><td>".$fst."</td></tr>\n";
	}
	if (isValid($rc->web_link)) {
	    echo "<tr><th class = \"left\" rowspan=\"2\">Web-Link</th><td>".$rc->web_link;
	    if (substr($row->web_link, 0,1) == '#'){
	        $mrl = $query->getReportMetaRecord(substr($row->web_link, 1));
	        if (false) $mrl = new MetaRecord();
	        if ($mrl != null){
	            if (isValid($mrl->displayVar))  echo '<br>('.quoteForHTML($mrl->displayVar).')';
	            else
	                if (isValid(makeDescription($mrl)))  echo '<br>('.makeDescription($mrl).')';
	                else
	                    if (isValid($mrl->label))  echo '<br>('.quoteForHTML($mrl->label).')';
	                    else if (isValid($row->web_title)) echo '<br>('.quoteForHTML($row->web_title).')';
	        }
	    }	    
		echo "</td></tr>\n<tr><td>";
		if ($rc->reportLinkInValues) echo WSRTranslate::translateH("Link in Werten"); 
		  else echo WSRTranslate::translateH("Link in Spalten-Köpfen");
		  if ($rc->reportCopyFilter) echo" <i>(".WSRTranslate::translateH('alle Filter übernehmen').")</i>"; 
		echo "</td></tr>\n";
	}
	
	} // for
?>
</table>
<?php	
	}
}
?>
<p>
<?php if ($query->repTables->size() > 0){
	?>
	<p>
	<h3><?=WSRTranslate::translateH('Übersicht zur Zuordnung der verknüpften Tabellen')?></h3>
	<table id="Tabelle1u" <?=$border?> class="aLeft">
	<thead>
	<tr><th><?=WSRTranslate::translateH('Zeilen-Var.')?></th>
	<?php	
	 for ($j=0; $j < $query->repTables->size(); $j++ ) {
		$join = $query->repTables->getPos($j);
		$rq = $join->query;
		//rq.outputTitlePrefix
	?>
	<th> <?php if (isValid($join->prefix)) echo $join->prefix; else  echo $join->kennzeichen;?></th>
	<?php }  ?>	
	<tr>
	</thead>
	<?php
	  for ($i = 0; $i < $query->repRows->size(); $i++){
	      if (!$query->repRows->getPos($i)->webLinkColumn){
		  $name = $query->repRows->getPos($i)->getName();
		  $mr = $query->getReportMetaRecord($name);
	?>	  
	<tr>
	<th class="left" title = "<?=makeTitleDescription($mr)?>"><?=quoteForHTML($mr->label)?></th>
<?php
	if ($query->repTables->size() > 0)	
	 for ($j=0; $j < $query->repTables->size(); $j++ ) {
		$join = $query->repTables->getPos($j);
		$rq = $join->query;
		$jkz = "&nbsp;";
		if (false !== array_search($name, $rq->rowVars)) {
			$jkz = "&rArr;";
			// Hier Filter prüfen
			if ($query->repFilter->has($join->kennzeichen.":".$name)){
			    $filter = $query->repFilter->get($join->kennzeichen.":".$name);
			    if (isValid($filter->fs_von) || isValid($filter->fs_bis)) $jkz = "&otimes;";
			    else $jkz = "&empty;";
			}			     
		}
	?>
	<td class="center"><?=$jkz?></td>
	<?php }  ?>	
	</tr>
<?php 
	      }
}
if ($query->values_in_columns && $query->repColumns->size() >0){
?>
	<tr><th><?=WSRTranslate::translateH('Spalten-Var')?>.</th><th colspan="<?=$query->repTables->size()?>">&nbsp;</th></tr>
<?php	
for ($i = 0; $i < $query->repColumns->size(); $i++){	
	  $name = $query->repColumns->getPos($i)->getName();
	  $mr = $query->getReportMetaRecord($name);
?>	  
<tr>
<th class="left" title = "<?=makeTitleDescription($mr)?>"><?=quoteForHTML($mr->label)?></th>
<?php
if ($query->repTables->size() > 0)	
for ($j=0; $j < $query->repTables->size(); $j++ ) {
	$join = $query->repTables->getPos($j);
	$rq = $join->query;
	$jkz = "&nbsp;";
	if (false !== array_search($name,$rq->rowVars)) {
		$jkz = "&rArr;";
		// Hier Filter prüfen
		if ($query->repFilter->has($join->kennzeichen.":".$name)){
		    $filter = $query->repFilter->get($join->kennzeichen.":".$name);
		    if (isValid($filter->fs_von) || isValid($filter->fs_bis)) $jkz = "&otimes;";
		    else $jkz = "&empty;";
		}
?>
<td class="center"><?=$jkz?></td>
<?php }  // Schleifenende Joins 
} // Schleifen-Ende Rows?>
</tr>
<?php
} // if repColumns	
	}
	?>
	</table>
<div class="small">
<b><?=WSRTranslate::translateH('Symbole')?>:</b><br>
<?=WSRTranslate::translateH('(leer): in dieser Quelle nicht vorhanden')?><br>
&rArr;: <?=WSRTranslate::translateH('wird aus Basistabelle übernommen')?><br>
&otimes;: <?=WSRTranslate::translateH('gesperrt durch expliziten Filter')?><br>	 
&empty;: <?=WSRTranslate::translateH('gesperrt durch leeren Filter-Eintrag')?>	 
</div>
<?php  } // if joins: Zeilenübersicht
?>

<p>

<h3><?=WSRTranslate::translateH('Werte')?></h3>
<table id="Tabelle2" <?=$border?>  class="aLeft">
<thead>
<tr><th><?=WSRTranslate::translateH('Var.')?></th>
<th><?=WSRTranslate::translateH('Beschreibung')?></th>
<th><?=WSRTranslate::translateH('Charts')?></th><th><?=WSRTranslate::translateH('Skalierung')?></th></tr>
<tr>
</thead>
<?php
    $maxFunctionenLevel = $query->repRows->size();
    for($ir = $query->repRows->size() -1; $ir > 0 &&  $query->repRows->getPos($ir)->webLinkColumn ; $ir--){
        $maxFunctionenLevel --;
        error_log('Web-Link ergibt '.$maxFunctionenLevel);
    }
    if (!$query->values_in_columns)    $maxFunctionenLevel --;

  for ($i = 0; $i < $query->repValues->size(); $i++){
      /**
       * 
       * @var RepValue $repVal
       */
      $repVal = $query->repValues->getPos($i);
	  $name = $repVal->getValueName();
	  $mr = $query->getReportMetaRecord($name);
	  $label = $mr->label;
	  if (substr($name,1,1) == ":" || substr($name,1,1) == "="){
	      $jtp = $query->repTables->get(substr($name,0,1))->prefix;	      
	      if (isValid($jtp)){
	          if (substr($jtp,strlen($jtp)-1) == ':') $jtp = substr($jtp,0,strlen($jtp)-1);	          
		      $label = "<i>".$jtp."</i>".substr($name,1,1)." ".$label;
	      }
		  else $label = substr($name,0,2).$label;
	  }
	  if ($repVal->isWindowValue()) 
	      $label = '# '.quoteForHTML(RepValue::getFunctionText($repVal->function)).' '.WSRTranslate::translate('aus').' '.$label;
	  $dLabel = $query->repValues->getPos($i)->label;
	  if ($dLabel != null) $label.='<br> ('.$dLabel.')';
?>	  
<tr><th class="left" ><?=$label?></th>
<td><?php 
if ($repVal->isWindowValue()){    
    echo quoteForHTML(RepValue::getFunctionDesc($repVal->function));
    if ($repVal->abSpalte > 0 && $query->repRows->size() >= $repVal->abSpalte){
        echo ' '.WSRTranslate::translate('in').' '
            .$query->getReportMetaRecord($query->repRows->getPos($repVal->abSpalte -1)->getName())->label;
    }    
    if ($repVal->nachSpalten && $query->values_in_columns) echo ' '.WSRTranslate::translate('nach Spalten');    
    echo ":<br>\n";
    
    // FEHLER-Meldung bei ungültigen Daten
    error_log($repVal->getName().' nach Spalten '.$repVal->nachSpalten.' ab Spalte '.$repVal->abSpalte.' max: '.$maxFunctionenLevel);
    if ( ( $repVal->nachSpalten && $repVal->abSpalte >= $maxFunctionenLevel)
        || $repVal->abSpalte >$maxFunctionenLevel){
        echo '<b>'.WSRTranslate::translate('Fehler: Die Ebene').' ';
        if ($query->repRows->size() >= $repVal->abSpalte)
            echo $query->getReportMetaRecord($query->repRows->getPos($repVal->abSpalte -1)->getName())->label;
        else  echo WSRTranslate::translate('Nr.').' '.$repVal->abSpalte;    
        echo ' '.WSRTranslate::translate('ist unzulässig und wird ignoriert').".</b><br>\n";
    }
}
echo makeDescription($mr); 
if ($query->repValues->getPos($i)->keineSummen) 
    echo '<br>('.WSRTranslate::translateH('Keine Werte für Insgesamt-Zeilen').')';?></td>
<?php 
if ($mr->enterValue){
    echo '<td colspan="2">'.WSRTranslate::translateH('Eingabefeld').'</td>';
}else{
        $t = DisplayOptions::klartext[$query->repValues->getPos($i)->dispVal]; 
        if ($t == 'nur Zahlen') echo '<td colspan="2">&nbsp;</td>';
        else echo '<td>'.$t.'</td><td class = "center">'
            .ChartOptions::klartext[$query->repValues->getPos($i)->skalierung].'</td>';
}
        ?>
</tr>
<?php } ?>
</table>
<div class="small">
<b><?=WSRTranslate::translateH('Symbole')?>:</b><br>
: <?=WSRTranslate::translateH('Wert aus verknüpfter Datenquelle')?><br>
= <?=WSRTranslate::translateH('Berechnung aus Basisquelle und verknüpfter Datenquelle')?><br>
# <?=WSRTranslate::translateH('Funktion')?><br>
<?=WSRTranslate::translateH('Unter Zeilen-Var. in Klammern ggf. abweichende Spalten-Überschrift')?>
</div>
<p>
<?php 
	if ($query->repWerteBasis != null){
	    $mr = $query->getReportMetaRecord('WSR_WERTELISTE');
	    $options = $mr->getSelectOptions();
	    
	    foreach ($options as $opt){
	        if ($opt[0] == $query->repWerteBasis)
	            $basisWert = $opt[1];
	    }
	    ?>
<h3><?=WSRTranslate::translateH('Werte-Auswahl')?></h3>
<p><?=WSRTranslate::translateH('Die Werte zu')?> <b><?=$basisWert ?></b> 
<?=WSRTranslate::translateH('können über die Werte-Auswahl durch folgende Werte ersetzt werden')?>:
<ul>

<?php 
        foreach ($options as $opt){
           if ($opt[0] != $query->repWerteBasis)
               echo '<li> '.$opt[1]."</li>\n";
        }
?>
</ul>
</p>
<?php
	} // repWerteBasis
	if (!$query->values_in_columns && $query->repColumns->size() > 0){
?>		
<p><h3>Spalten</h3>
<table id="TabelleS" <?=$border?>  class="aLeft">
	
<?php	
	for ($i = 0; $i < $query->repColumns->size(); $i++){
	    /**
	     * @var RepColumn $rc
	     */
	    $rc = $query->repColumns->getPos($i);
	    $mr = $query->getReportMetaRecord($rc->getName());
	    if ($mr != null) $colLabel = $mr->label;
	    else $colLabel = WSRTranslate::translateH("FEHLER: Keine Metadaten für")." ".$rc->getName();
	    
	    $rowSpan = 1;
	    if ($rc->sort > Sort::NONE) $rowSpan ++;
	    if (isValid($rc->val_name)) {
	        $rowSpan ++;
	        if ($rc->keineSummen) $rowSpan ++;
	        if ($rc->function > 0) $rowSpan ++;
	    }
	    if (isValid($rc->filter)) $rowSpan += 2;
	    if (isValid($rc->web_link)) $rowSpan += 2;
	    if (substr($rc->getName(),1,1) == ':') {
	        $rowSpan ++;
	        $jt = $query->repTables->get(substr($rc->getName(),0,1));
	        $quelle = $jt->prefix;
	        if (!isValid($quelle)) $quelle = $jt->kennzeichen;
	        $quelle .= ' ('.$jt->query->class_table.')';
	    }
	    ?>
	<tr><th class="top left" rowspan = "<?=$rowSpan?>"><?=quoteForHTML($colLabel)?></th>
	<th class = "left">Label</th><td colspan="2"><?=quoteForHTML($rc->label)?></td></tr>
<?php  
    if ($rc->sort > Sort::NONE) echo "<tr><th class = \"left\">"
     .WSRTranslate::translateH('Sortierung').'</th><td>'.SORT::getKlartext($rc->sort)."</td></tr>\n";
	if (substr($rc->getName(),1,1) == ':') {
	    echo "<tr><th class = \"left\">".WSRTranslate::translateH('Quelle')."</th><td>".$quelle."</td></tr>\n";
	}
	if (isValid($rc->val_name)) {
	    $mr = $query->getReportMetaRecord($rc->val_name);
	    echo "<tr><th class = \"left\">".WSRTranslate::translateH('Wert')."</th><td>".$mr->label.'</td>';
	    if ($rc->displayOption !=  DisplayOptions::ZAHL){
	        echo '<td>'.DisplayOptions::klartext[$rc->displayOption].'</td>';
	           echo '<td class = "center">Skal.: '.ChartOptions::klartext[$rc->skalierung].'</td>';
	    }
//	    else echo '<td colspan="2">&nbsp;</td>';
	    echo "</tr>";
	    if ($rc->keineSummen) {
	        echo '<tr><th >&nbsp;</th><td>'.WSRTranslate::translateH('Keine Werte für Insgesamt-Zeilen').'</td></tr>';
	    }
	    if ($rc->function > 0){
	        echo "<tr><th class = \"left\">".quoteForHTML(RepValue::getFunctionText($rc->function))
	        // WSRTranslate::translateH('Funktion')
	        ."</th><td colspan = \"2\">";
	        // .RepValue::getFunctionText($rc->function).'</td>';
	        echo quoteForHTML(RepValue::getFunctionDesc($rc->function));
	        if ($rc->abSpalte > 0 && $query->repRows->size() >= $rc->abSpalte){
	            echo ' '.WSRTranslate::translate('in Zeilen').': ';
                echo $query->getReportMetaRecord($query->repRows->getPos($rc->abSpalte -1)->getName())->label;
	        }
	        if ($rc->nachSpalten) echo '<br>'.WSRTranslate::translate('nach Spalten');
	        echo "\n</td></tr>";
	        
	    }
	}
	
	if (isValid($rc->filter)) {
	    $mr = $query->getReportMetaRecord($rc->filter);	    
	    if ($mr != null) echo "<tr><th class = \"left\" rowspan=\"2\">".WSRTranslate::translateH('Filter')."</th><td"
                                .makeTitle(makeTitleDescription($mr)).">".$mr->label."</td></tr>\n";
       else echo "<tr><th class = \"left\" rowspan=\"2\">".WSRTranslate::translateH('Filter')."</th><td>".$rc->filter." "
                    .WSRTranslate::translateH('OHNE NETADATEN')."</td></tr>\n";
		$filter = new RepFilter($rc->filter);
		$filter->fs_von = $rc->fs_von;
		$filter->fs_bis = $rc->fs_bis;
		$fst = showFilter($filter, false);
		if ($fst == null) echo "<tr><td>&lt;&lt;".WSRTranslate::translateH('nicht gesetzt')."&gt;&gt;</td></tr>\n";
		echo "<tr><td>".$fst."</td></tr>\n";
	}
	if (isValid($rc->web_link)) {
	    echo "<tr><th class = \"left\" rowspan=\"2\">".WSRTranslate::translateH('Web-Link')
	           ."</th><td>".$rc->web_link."</td></tr>\n";
		echo "<tr><td>";
		if ($rc->reportLinkInValues) echo WSRTranslate::translateH("Link in Werten"); 
		else echo WSRTranslate::translateH("Link in Spalten-Köpfen");
		if ($rc->reportCopyFilter) echo" <i>(".WSRTranslate::translateH('alle Filter übernehmen').")</i>"; 
		echo "</td></tr>\n";
	}
	
	} // for
	?>
</table>
<?php	
	
} // ENDE Spalten
?>
<p>

<h3><?=WSRTranslate::translateH('Filter')?></h3>
<table id="Tabelle3" <?=$border?>  class="aLeft">
<thead>
<tr><th><?=WSRTranslate::translateH('Filter')?></th><th><?=WSRTranslate::translateH('Auswahl')?></th>
<th><?=WSRTranslate::translateH('Beschreibung')?></th><th><?=WSRTranslate::translateH('Optionen')?></th></tr>
</thead>
<?php
  for ($fi=0; $fi< $query->repFilter->size(); $fi++){
      $filter = $query->repFilter->getPos($fi);
      if (false) $filter = new RepFilter('NÄ');
      $fName = $filter->getName();
      if ($filter->isWindowFilter()){
          if (false) $filter = new WindowFilter('');
          $mr = $filter->getMetaRecord();
          $fLabel = '# '.$mr->label;
      }else{
    	  $mr = $query->getReportMetaRecord($fName);
    	  $fLabel = $mr->label;
      }
	  if (substr($fName,1,1) == ':') {
	      $jtp = trim($query->repTables->get(substr($fName,0,1))->prefix);
	      if (substr($jtp,strlen($jtp)-1) == ':') $jtp = substr($jtp,0,strlen($jtp)-1);
	      if (isValid($jtp)) $fLabel = '<i>'.$jtp.'</i>: '.$fLabel;
	      else $fLabel = substr($fName,0,2).$fLabel;
	  }	
	  if ($filter->isValueFilter()){
	      $fLabel = '$ '.$fLabel;
	  }
	  $fText = showFilter($filter, false);	 
	  if ($fText == null) {
	      if ($filter->selectorImOutput) $fText .= '(*)';
	      else $fText = "&nbsp;";	      
	  }
	  ?>
<tr><th class="left" ><?=$fLabel?></th>
<td><?=quoteForHTML($fText)?></td>	
<td><?=makeDescription($mr)?></td>
<td class="nowrap"><?php
if ($mr->hidden) echo WSRTranslate::translateH('verborgen')."<br>\n";
if ($filter->selectorImOutput) echo WSRTranslate::translateH('Auswahl in Ausgabe')."<br>\n";
if ($filter->inTitelZeile > 0) {
    echo WSRTranslate::translateH('Anzeige in').' '.$filter->inTitelZeile.' '
     .WSRTranslate::translateH('Zeile')."<br>\n";
     if ($filter->inTitelMitLabel) echo WSRTranslate::translateH('mit Label')."<br>\n";        
}
if ($filter->abSpalte > 0){
    $qRows = $query->repRows;
    if ($qRows != null){
        $mrs = $query->metaData[$qRows->getPos($filter->abSpalte-1)->getName()];
        if ($mrs != null) echo WSRTranslate::translateH('wirkt ab Spalte').' '.$mrs->label."<br>\n";
        else echo WSRTranslate::translateH('FEHLER bei Filter ab Spalte').' '.$filter->abSpalte."<br>\n";
    }
}
if ($filter->reportCopyFilter){
    ?>
<span class="help" title=
"<?=WSRTranslate::translateH("Normalerweise werden Filter aus der Report-Definition
beim Aufruf über die Links nicht übergeben.
Mit dieser Option wird der Filter so übergeben, als
wäre er im Aufruf gesetzt")?>"
    ><?=WSRTranslate::translateH('Filter immer übergeben')?></span><br>
<?php 
}
if ($filter->doNotTake){    
?>    
    <span class="help" title=
"<?=WSRTranslate::translateH('Filterwert aus dem Aufruf nicht übernehmen.
Damit können einzelne Filter von der Übernahme
ausgeschlossen werden, während die anderen
übernommen werden.')?>"
            ><?=WSRTranslate::translateH('Filter nicht übernehmen')?></span><br>
<?php 
}
?></td>
</tr>	  
<?php	  
  }
  ?>
  
</table>
<div class="small">
<b><?=WSRTranslate::translateH('Symbole in Auswahl')?>:</b><br>
(*) <?=WSRTranslate::translateH('Benutzerfilter: Kann vom Benutzer in der Ausgabe gesetzt und geändert werden.')?><br>
$ <?=WSRTranslate::translateH('Werte-Filter wirkt nur auf Anzeige')?>.<br>
# <?=WSRTranslate::translateH('Auswahl-Filter wirkt nur auf Anzeige')?>.
</div>
<?php if ($query->repReports->size()>0) {?>
<h3><?=WSRTranslate::translateH('Verweise auf weitere Reports')?></h3>
<table id="Tabelle4" <?=$border?>  class="aLeft">
<thead>
<tr><th><?=WSRTranslate::translateH('Report')?></th>
<th><?=WSRTranslate::translateH('Kommentar')?></th><th><?=WSRTranslate::translateH('Filter<br>übernehmen')?></th></tr>
</thead>
<?php
  for ($fi=0; $fi< $query->repReports->size(); $fi++){
      $rep = $query->repReports->getPos($fi);
      $rName = $rep->getName();
	  ?>
<tr><th class="left" ><a href="./reportReportDef.php?report=<?=$rName?>"><?=$rName?></a></th>
<td><?=quoteForHTML($rep->kommentar)?></td>	
<td class="center"><?php if($rep->copyFilter) echo 'X'; else echo '&nbsp;'; ?></td>
</tr>	  
<?php	  
  }
  ?> 
</table>
<?php	  
  }
  ?>
<h3><?=WSRTranslate::translateH('Beschreibung der Quellen')?></h3>

<?php 
$qdv = array();
$qdv[$query->class_table] = 1;
echo '<div class="kommentar lw">';
echo "<b>{$query->class_table}</b> ({$query->outputTitlePrefix})<br>";
echo quoteForHTML($query->table_description);
echo '</div>';
for ($i=0; $i < $query->repTables->size(); $i++){
    /**
     * @var Query $jQ
     */
    $jQ = $query->repTables->getPos($i)->query;
    
    if (!array_key_exists($jQ->class_table, $qdv)){
        echo "<br><br>\n";
        echo '<div class="kommentar lw">';
        echo "<b>{$jQ->class_table}</b> ({$jQ->outputTitlePrefix})<br>";
        echo quoteForHTML($jQ->table_description);
        if (isValid($jQ->table_hints)){
            echo "\n<br><b>".WSRTranslate::translate('Technische Hinweise').":</b><br>\n";
            echo quoteForHTML($jQ->table_hints);
            echo "<br>\n";
        }
        echo '</div>';
    }
}
?>
  
  
</div>


<footer class="leiste">
<div class="Fleft">WS Reporting Version <?=$wsReportVersion?></div>
<div class="Fright right">&copy; WS Unternehmensberatung</div>
</footer>
</body>
</html>
</body>
</html>

