<?php
/**
 * Projekt: WS-Reporter
 *          Auflistung der Datenquellen, in denen eine Dimension verwendet wird.
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    24.1.2022
 *
 */
include 'includes/defender.inc';

require_once './includes/funktionen.inc';
require_once './includes/classes.inc';

if (session_status() == PHP_SESSION_NONE)  session_start();
anmeldungPruefen();

if (array_key_exists('WSReportQuery', $_SESSION)){
    $query = $_SESSION['WSReportQuery'];
}
session_write_close();

if ($query == null){
    echo "FEHLER: Aufruf ohne Datenquelle .";
    die();
}


$sql = new SqlAbfrage('WSR');
$sql->sql = 'select d.table_name, d.qHistType, a.attribute '
      .' from queryDimensions d '
      .' left join queryAttribute a on a.table_name = d.table_name and a.SatzTyp = 2';
$sql->addSel('d.qDimName = ', $query->class_table);
$stmt = $sql->execute();
if ($stmt === false ){
    die();
}
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>WS-Reporter: Verwendung der Dimension <?=$query->class_table ?> in Datenquellen</title>
<meta name="GENERATOR" content="WS-PHP: showDimUse.php">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="<?=$query->reportCSS ?>" >
</head> 
<?php 
if ($_SERVER["HTTP_HOST"] == "localhost:8898") echo '<body class="entwicklung">';
else echo '<body>';
?>
<h1>Verwendung der Dimension <?=$query->class_table ?> in Datenquellen</h1>
<table>
<thead>
<tr><th>Datenquelle</th><th>Beschreibung</th><th>Historisierung</th>
<th>Bearbeiten</th></tr>
</thead>
<tbody>
<?php
while ($z = $stmt->fetchObject()){
?>
<tr><th class="left" ><?=$z->table_name ?></th>
	<td> <?=$z->attribute ?></td>
	<td> <?=Query::getHistText($z->qHistType) ?></td>
 	<td><a href="editQuery.php?table=<?=$z->table_name ?>" target="QueryEditor">bearbeiten</a></td>
 	</tr>
<?php
}
?>
</tbody></table>
</body>
</html>


