<?php
/**
 * Projekt: WS-Reporter
 *          SQL für Test der Datenquelle anzeigen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.10.2021
 *
 */
include 'includes/defender.inc';
// Ausgabe des SQL-Codes zur Fehlersuche
global $query, $meldungen;
require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
global $query, $wsReportVersion, $sourceSQL ; 
$meldungen = "";
if (false) $query = new Query("dummy");
$query = null;
$sourceSQL = true;
if (session_status() == PHP_SESSION_NONE)  session_start();

if (array_key_exists('WSReportQuery', $_SESSION)){
    $query = $_SESSION['WSReportQuery'];
}
session_abort();
if ($query == null ){
    echo "FEHLER:<br>Die Datenquelle konnte nicht geladen werden.";
    die();
}
anmeldungPruefen();
if (!dqAdminRechte()){
    http_response_code(425);
    echo "Für diese Operation sind die Administrator-Rechte \nfür die Datenquelle erforderlich";
    die;
}

$meldungen ='';
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title><?=$query->outputTitlePrefix ?>: SQL für Test der Datenquelle</title>
<meta name="GENERATOR" content="WS-PHP: showSQL.php">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="./jscss/WSReport.css" >
</head> 
<body>
<h1>SQL für Test der Datenquelle: <?=$query->class_table?></h1>
<div class="article white">
<?php
  $testSQL = 1;
 require './includes/eqpTest.inc';
 ?>
</div>
</body>
</html>
