<?php 
/**
 * Projekt: WS-Reporter
 *          Übersetzungen eines Textes in der Anwendung
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    15.8.2022
 *
 * Hinweise:
 * Hier wird ein einzelner Text zum Übersetzen angezeigt.
 * Aufruf aus helpTranslate.js
 *
 */

/* ??
 if (array_key_exists('class_table', $_REQUEST)){
 $sql = new SqlAbfrage('WSR');
 $sql->sql =
 }
 */
include 'includes/defender.inc';

require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
require_once './includes/qTranslate.inc';
require_once './includes/wsrTranslate.inc';
if (session_status() == PHP_SESSION_NONE)  session_start();
anmeldungPruefen();
adminRechteVerlangen();

error_log("Call translate WS-Reporter ".print_r($_REQUEST,true));

if (!array_key_exists('text', $_REQUEST)){
    echo 'FEHLER: Parameter Text fehlt';
    die();
}
$text = wsrDecode($_REQUEST['text']);
/* Liste der zu übersetzenden Texte */
$sql = new SqlAbfrage('WSR');
$sql->sql = 'select zaehler, qLanguageType, de, en, fr from wsrTranslations';
$sql->addSel('de = ', $text);
$stmt = $sql->execute();
if ($stmt === false){
    echo '<h2>FEHLER: im SQL-Statement</h2>';
    echo $sql->sql;
    echo '<br><br>';
    echo $sql->errorInfo()[2];
    die();
}
$z = $stmt->fetch(PDO::FETCH_ASSOC);
if ($z=== false){
    echo '<h2>FEHLER: Text nicht gefunden</h2>';
    echo $text;
    die();
}
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title><?=WSRTranslate::translate('Übersetzung des WS-Reporters')?></title>
<meta name="GENERATOR" content="WS-PHP: translateWS-Reporter.php">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="./jscss/WSReport.css" >
<script type="text/javascript" src="./jscss/wsrTranslate.js">
	</script>
</head>
<?php 
if ($_SERVER["HTTP_HOST"] == "localhost:8898"){
    ?>
<body class = "entwicklung">	
<?php
} else echo '<body>';
?>

<h1><?=WSRTranslate::translate('Übersetzung')?></h1>

<?php

$rows = 0;
$t = explode("\n",$z['de']);
foreach ($t as $tz)
    if (strlen($tz) > 150) $rows += 4;
    elseif (strlen($tz) > 100) $rows += 3;
    elseif (strlen($tz) > 50) $rows += 2;
    else $rows++;
    
    ?>
<b>DE:</b>
<textarea rows="<?=$rows?>" cols="50" readonly id='D0' lang='de'>
<?=$z['de']?>
</textarea>

<br><br>  
<?php 
for ($l = 1; $l < count(qTranslate::SPRACHEN);$l++){
?>
<b><?=strtoupper(qTranslate::SPRACHEN[$l]) ?>:</b>
<textarea rows="<?=$rows?>" cols="50"  
lang="<?=qTranslate::SPRACHEN[$l] ?>" id ='<?=qTranslate::SPRACHEN[$l] ?>0'  
onchange='enter(this,"<?=qTranslate::SPRACHEN[$l] ?>","D0")' >
<?= $z[qTranslate::SPRACHEN[$l]]?>
</textarea>
<br><br>  

<?php 
}
?>
